'PROGRAM The Mega-ZZTer's Text Viewer

 ' The Subroutine Declarations
 DECLARE SUB DrawBars ()
 DECLARE SUB DrawBckground ()
 DECLARE FUNCTION Hex2Dec% (Text$)
 DECLARE SUB MakeOneByte (var%)
 DECLARE SUB OpenFile ()
 DECLARE SUB PrintEnhancedText ()
 DECLARE SUB PrintText ()
 DECLARE FUNCTION ProcessSpecialChar% (letter$)
 DECLARE SUB ReadFile (StartLine!)

 ON ERROR GOTO oops     ' Error trapping routine
  DIM SHARED Text$(1 TO 23)     ' The Text$ variable holds the current screen
                                ' of text.
  DIM SHARED CMD$, CurrentTopLine!, LeftOffset!, FileMode%, MaxLines!
  CurrentTopLine! = 1   'Stores the current line, the on eon the second row
                        'of the screen.
  LeftOffset! = 1       'The offset from the left side of the file, scrolling
                        'left and right.

  DIM SHARED TitleForeColor%, TitleBackColor%, MainDefFColor%, MainDefBColor%
  TitleForeColor% = 15
  TitleBackColor% = 1
  MainDefFColor% = 7
  MainDefBColor% = 0

   ' The above lines are for user-defined colors (for ET files.)

  DIM SHARED verNum$    'So I can just change this variable and not all the
  verNum$ = "v1.0"      'places in the program that use the number.

  OpenFile      'Open the file named in COMMAND$
  DrawBckground 'PRINT the screen background and and static bar info
 
  DO
   DrawBars     'PRINT the dynamic bar info
   ReadFile CurrentTopLine!     'Read the text
   IF FileMode% <> 1 THEN PrintText     'If the file does not have a valid ET
                                        'header, it's a normal text file.
   IF FileMode% = 1 THEN PrintEnhancedText      'Otherwise, process color-
                                                'changing codes.

   DO
    Key$ = INKEY$
   LOOP UNTIL Key$ <> ""        'Wait until the user presses a key.
   SELECT CASE Key$
    CASE CHR$(27)       'ESC key
     COLOR 7, 0
     CLS
     PRINT "Thank you for using The Mega-ZZTer's Text Viewer " + verNum$ + "!"
     END
    CASE CHR$(0) + "H"  'Up arrow key
     IF CurrentTopLine! > 1 THEN CurrentTopLine! = CurrentTopLine! - 1
    CASE CHR$(0) + "P"  'Down arrow key
     IF CurrentTopLine! < 2147483647 THEN
      CurrentTopLine! = CurrentTopLine! + 1
      IF CurrentTopLine! > MaxLines! - 22 THEN CurrentTopLine! = MaxLines! - 22
      IF CurrentTopLine! < 1 THEN CurrentTopLine! = 1
     END IF
    CASE CHR$(0) + "K"  'Left arrow key
     IF LeftOffset! > 1 THEN LeftOffset! = LeftOffset! - 1
    CASE CHR$(0) + "M"  'Right arrow key
     IF LeftOffset! < 2147483647 THEN LeftOffset! = LeftOffset! + 1
    CASE CHR$(0) + "G"  'Home key
     LeftOffset! = 1
    CASE CHR$(0) + "I"  'Page up key
     CurrentTopLine! = CurrentTopLine! - 23
     IF CurrentTopLine! < 1 THEN CurrentTopLine! = 1
    CASE CHR$(0) + "Q"  'Page down key
     IF CurrentTopLine! < 2147483647 THEN       '2147483647 is the limit for ! variables.
      IF CurrentTopLine! <= 2147483624 THEN     'The last two digits ARE
                                                'supposed to be 24.
       CurrentTopLine! = CurrentTopLine! + 23
      ELSE
       CurrentTopLine! = 2147483647
      END IF
      IF CurrentTopLine! > MaxLines! - 22 THEN CurrentTopLine! = MaxLines! - 22
      IF CurrentTopLine! < 1 THEN CurrentTopLine! = 1
     END IF
    CASE "["
     LeftOffset! = LeftOffset! - 40
     IF LeftOffset! < 1 THEN LeftOffset! = 1
    CASE "]"
     IF LeftOffset! <= 2147483607 THEN LeftOffset! = LeftOffset! + 40
   END SELECT
  LOOP

        'This line below isn't needed, but I put it in anyways...
END 'PROGRAM Inverse Square Text Viewer

        'This is my error routine.  You'll notice that it isn't made
        'specifically for this program, as it has an 'Out of Paper' message,
        'and this program doesn't use the printer...

oops:
 COLOR 7, 0
 CLS    'Switch to a standard DOS colored screen for easy readability.
 PRINT "Error "; LTRIM$(RTRIM$(STR$(ERR))); ": ";       'Tell the user the
                                                        'ERR number.
 SELECT CASE ERR
  CASE 1
   PRINT "`NEXT without FOR'.  Internal error, report to programmer."
  CASE 2
   PRINT "`Syntax error'.  Internal error, report to programmer."
  CASE 3
   PRINT "`RETURN without GOSUB'.  Internal error, report to programmer."
  CASE 4
   PRINT "`Out of DATA'.  Internal error, report to programmer."
  CASE 5
   PRINT "`Illegal function call'.  Internal error, report to programmer."
  CASE 6
   PRINT "`Overflow'.  Internal error, report to programmer."
  CASE 7
   PRINT "`Out of memory'.  Increase free conventional memory."
  CASE 8
   PRINT "`Label not defined'.  Internal error, report to programmer."
  CASE 9
   PRINT "`Subscript out of range'.  Internal error, report to programmer."
  CASE 10
   PRINT "`Duplicate definition'.  Internal error, report to programmer."
  CASE 11
   PRINT "`Division by zero'.  Internal error, report to programmer."
  CASE 12
   PRINT "`Illegal in direct mode'.  Internal error, report to programmer."
  CASE 13
   PRINT "`Type mismatch'.  Internal error, report to programmer."
  CASE 14
   PRINT "`Out of string space'.  Internal error, report to programmer."
  CASE 16
   PRINT "`String formula too complex'.  Internal error, report to"
   PRINT "programmer."
  CASE 17
   PRINT "Cannot continue.  If this error appears frequently, report"
   PRINT "to programmer."
  CASE 18
   PRINT "`Function not defined'.  Internal error, report to programmer."
  CASE 19
   PRINT "`No RESUME'.  Internal error, report to programmer."
  CASE 20
   PRINT "`RESUME without error'.  Internal error, report to programmer."
  CASE 24
   PRINT "Device timeout.  Test your computer's devices to make sure"
   PRINT "they function properly."
  CASE 25
   PRINT "Device fault.  Test your computer's devices to make sure"
   PRINT "they function properly."
  CASE 26
   PRINT "`FOR without NEXT'.  Internal error, report to programmer."
  CASE 27
   PRINT "Out of paper.  Please reload your printer and press any key."
   DO
    Key$ = INKEY$
   LOOP UNTIL Key$ <> ""
   RESUME
  CASE 29
   PRINT "`WHILE without WEND'.  Internal error, report to programmer."
  CASE 30
   PRINT "`WEND without WHILE'.  Internal error, report to programmer."
  CASE 33
   PRINT "`Duplicate label'.  Internal error, report to programmer."
  CASE 35
   PRINT "`Subprogram not defined'.  Internal error, report to programmer."
  CASE 37
   PRINT "`Argument-count mismatch'.  Internal error, report to programmer."
  CASE 38
   PRINT "`Array not defined'.  Internal error, report to programmer."
  CASE 40
   PRINT "`Variable required'.  Internal error, report to programmer."
  CASE 50
   PRINT "`FIELD overflow'.  Internal error, report to programmer."
  CASE 51
   PRINT "`Internal error'.  Report to programmer."
  CASE 52
   PRINT CMD$; " is not a valid file name."
  CASE 53
   PRINT "File not found.  Make sure DFRNTEND.TXT is in the"
   PRINT "current directory."
  CASE 54
   PRINT "`Bad file mode'.  Internal error, report to programmer."
  CASE 55
   PRINT "File is already open.  Windows users need to use SHARE.EXE or"
   PRINT "close the application using the file."
  CASE 56
   PRINT "`FIELD statement active'.  Internal error, report to programmer."
  CASE 57
   PRINT "`Device I/O error'.  Test your computer's devices to make sure"
   PRINT "they function properly."
  CASE 58
   PRINT "`File already exists'."
  CASE 59
   PRINT "`Bad record length'.  Make sure the data file you are using is for"
   PRINT "this program and it is the correct version."
  CASE 61
   PRINT "`Disk full'.  Free some space and try again."
  CASE 62
   PRINT "Unexpected end of file.  File may be corrupt."
  CASE 63
   PRINT "`Bad record number'.  This may be an internal error.  Report"
   PRINT "to programmer."
  CASE 64
   PRINT CMD$; " is not a valid file name."
  CASE 67
   PRINT "Could not open the file.  Too many files are open.  Increase"
   PRINT "the `FILES' entry in CONFIG.SYS and reboot."
  CASE 68
   PRINT "`Device unavailable'.  Close and programs that are using the"
   PRINT "device and try again."
  CASE 69
   PRINT "`Communication-buffer overflow'.  This mat be an internal error."
   PRINT "Report to programmer."
  CASE 70
   PRINT "Access denied.  Have your network administrator enable access"
   PRINT "for the file."
  CASE 71
   PRINT "`Disk not ready'.  Insert the disk/CD and make sure the drive"
   PRINT "is closed."
  CASE 72
   PRINT "`Disk-media error'.  The disk may be damaged, or it may have"
   PRINT "to be formatted, if it's a floppy."
  CASE 73
   PRINT "This program cannot be run within QBASIC.  Run with QuickBASIC."
  CASE 74
   PRINT "You cannot use rename to move a file across disks."
  CASE 75
   PRINT "`Path/File acess error'.  Check the name and try again."
  CASE 76
   PRINT "`Path not found'.  Check the name and try again."
  CASE ELSE
   PRINT "No help information available for this error.  Look it up"
   PRINT "in a Run-Time Error Table."
 END SELECT
END 'oops

SUB DrawBars
 COLOR TitleForeColor%, TitleBackColor%
 LOCATE 1, 62
 PRINT USING "Line _#: ##########"; CurrentTopLine!;
 LOCATE 25, 60
 PRINT USING "Vert Pos: ##########"; LeftOffset!;
 LOCATE 1, 48
 IF CurrentTopLine! + 22 >= MaxLines! THEN
  PRINT "[End of File]";
 ELSE
  IF CurrentTopLine! = 1 THEN
   PRINT "[Top of File]";
  ELSE
   PRINT "             ";
  END IF
 END IF
END SUB 'DrawBars

SUB DrawBckground
 COLOR TitleForeColor%, TitleBackColor%
 CLS
 COLOR MainDefFColor%, MainDefBColor%
 LOCATE 2, 1
 PRINT STRING$(1840, " ");
 LOCATE 1, 2
 COLOR TitleForeColor%, TitleBackColor%
 IF LEN(CMD$) <= 45 THEN
  PRINT CMD$;
 ELSE
  PRINT "..."; RIGHT$(CMD$, 42)
 END IF
 LOCATE 25, 2
 PRINT CHR$(24); CHR$(25); CHR$(27); CHR$(26); " - Scroll Up/Down, Left/Right  ESC - Quit";
END SUB 'DrawBckground

FUNCTION Hex2Dec% (Text$)
 Text$ = LEFT$(Text$, 1)
 IF LTRIM$(RTRIM$(STR$(VAL(Text$)))) = Text$ THEN
  Hex2Dec% = VAL(Text$)
  EXIT FUNCTION
 END IF
 Hex2Dec% = ASC(Text$) - 55
END FUNCTION

SUB MakeOneByte (var%)
 DO UNTIL var% >= 0
  var% = var% + 256
 LOOP
 DO UNTIL var% <= 255
  var% = var% - 256
 LOOP
END SUB 'MakeOneByte (var%)

SUB OpenFile
 DIM temp%(1 TO 12)

 CMD$ = "DFRNTEND.TXT"
 IF CMD$ = "" OR CMD$ = "-?" OR CMD$ = "?" OR CMD$ = "/?" THEN
  PRINT "Syntax:  TEXTVIEW.EXE  { Filename }"
  PRINT
  PRINT "  Opens a text file or an ET file for viewing."
  END
 END IF
 IF INSTR(CMD$, ".") = 0 THEN
  CMD$ = CMD$ + ".ET"
 END IF
 OPEN CMD$ FOR INPUT AS #1
 CLOSE
 OPEN CMD$ FOR BINARY AS #1
 AString$ = ""
 FOR i% = 1 TO 11
  GET #1, i%, temp%(i%)
  MakeOneByte temp%(i%)
 
  AString$ = AString$ + CHR$(temp%(i%))
 NEXT i%
 IF AString$ = " " + CHR$(2) + " ۲" THEN FileMode% = 1
 IF FileMode% = 1 THEN
  GET #1, 12, tempy%
  MakeOneByte tempy%
  TitleForeColor% = Hex2Dec%(CHR$(tempy%))
  GET #1, 13, tempy%
  MakeOneByte tempy%
  TitleBackColor% = Hex2Dec%(CHR$(tempy%))
  GET #1, 14, tempy%
  MakeOneByte tempy%
  MainDefFColor% = Hex2Dec%(CHR$(tempy%))
  GET #1, 15, tempy%
  MakeOneByte tempy%
  MainDefBColor% = Hex2Dec%(CHR$(tempy%))
 END IF
 CLOSE
 OPEN CMD$ FOR INPUT AS #1
 IF FileMode% = 1 THEN LINE INPUT #1, dummy$
 MaxLines! = 0
 DO UNTIL EOF(1)
  LINE INPUT #1, dummy$
  MaxLines! = MaxLines! + 1
  IF FileMode% = 1 AND LTRIM$(RTRIM$(dummy$)) = " EOF ۲" THEN
   MaxLines! = MaxLines! - 1
   EXIT DO
  END IF
 LOOP
 CLOSE
 OPEN CMD$ FOR INPUT AS #1
 IF FileMode% = 1 THEN LINE INPUT #1, dummy$
END SUB 'OpenFile

SUB PrintEnhancedText
 FOR i% = 1 TO 23
  c1% = MainDefFColor%
  c2% = MainDefBColor%
  COLOR c1%, c2%
  CurrentChar! = 1
  SpecialChar$ = ""
  LOCATE 1 + i%, 1
  FOR j% = 1 TO LEN(Text$(i%))
   temp$ = MID$(Text$(i%), j%, 1)
   IF SpecialChar$ = "~" THEN
    dummy% = ProcessSpecialChar%(temp$)
    IF dummy% <> -1 THEN
     c1% = dummy%
     COLOR c1%, c2%
    END IF
    IF dummy% = -1 AND temp$ = "~" THEN
     IF CurrentChar! >= LeftOffset! AND CurrentChar! <= LeftOffset! + 79 THEN
      PRINT temp$;
     END IF
     CurrentChar! = CurrentChar! + 1
    END IF
    temp$ = ""
   END IF
   IF SpecialChar$ = "@" THEN
    dummy% = ProcessSpecialChar%(temp$)
    IF dummy% <> -1 THEN
     c2% = dummy%
     COLOR c1%, c2%
    END IF
    IF dummy% = -1 AND temp$ = "@" THEN
     IF CurrentChar! >= LeftOffset! AND CurrentChar! <= LeftOffset! + 79 THEN
      PRINT temp$;
     END IF
     CurrentChar! = CurrentChar! + 1
    END IF
    temp$ = ""
   END IF
   SpecialChar$ = ""
   IF temp$ = "~" OR temp$ = "@" THEN SpecialChar$ = temp$
   IF SpecialChar$ = "" AND temp$ <> "" THEN
    IF CurrentChar! >= LeftOffset! AND CurrentChar! <= LeftOffset! + 79 THEN
     PRINT temp$;
    END IF
    CurrentChar! = CurrentChar! + 1
   END IF
  NEXT j%
  IF CurrentChar! <= LeftOffset! + 79 AND CurrentChar! > LeftOffset! THEN
   LOCATE i% + 1, CurrentChar! - LeftOffset! + 1
   PRINT STRING$(80 - (CurrentChar! - LeftOffset!), " ");
  END IF
  IF CurrentChar! <= LeftOffset! THEN
   LOCATE i% + 1, 1
   PRINT STRING$(80, " ");
  END IF
 NEXT i%
END SUB 'PrintEnhancedText

SUB PrintText
 FOR i% = 1 TO 23
  IF LEN(Text$(i%)) < LeftOffset! THEN Text$(i%) = STRING$(80, " ")
  IF LEN(Text$(i%)) < LeftOffset! + 79 THEN
   Text$(i%) = RIGHT$(Text$(i%), LEN(Text$(i%)) - LeftOffset! + 1)
   Text$(i%) = Text$(i%) + STRING$(80 - LEN(Text$(i%)), " ")
  END IF
  IF LEN(Text$(i%)) >= LeftOffset! + 79 THEN Text$(i%) = MID$(Text$(i%), LeftOffset!, 80)
 NEXT i%
 COLOR MainDefFColor%, MainDefBColor%
 FOR i% = 1 TO 23
  LOCATE i% + 1, 1
  PRINT Text$(i%);
 NEXT i%
END SUB 'PrintText

FUNCTION ProcessSpecialChar% (letter$)
 temp$ = UCASE$(letter$)
 IF temp$ = LTRIM$(RTRIM$(STR$(VAL(temp$)))) THEN
  ProcessSpecialChar% = VAL(temp$)
  EXIT FUNCTION
 END IF
 IF temp$ = "A" THEN
  ProcessSpecialChar% = 10
  EXIT FUNCTION
 END IF
 IF temp$ = "B" THEN
  ProcessSpecialChar% = 11
  EXIT FUNCTION
 END IF
 IF temp$ = "C" THEN
  ProcessSpecialChar% = 12
  EXIT FUNCTION
 END IF
 IF temp$ = "D" THEN
  ProcessSpecialChar% = 13
  EXIT FUNCTION
 END IF
 IF temp$ = "E" THEN
  ProcessSpecialChar% = 14
  EXIT FUNCTION
 END IF
 IF temp$ = "F" THEN
  ProcessSpecialChar% = 15
  EXIT FUNCTION
 END IF
 ProcessSpecialChar% = -1
END FUNCTION 'ProcessSpecialChar% (letter$)

SUB ReadFile (StartLine!)
 EndOfFile% = 0
 FOR i% = 1 TO StartLine! - 1
  LINE INPUT #1, dummy$
 NEXT i%
 FOR i% = 1 TO 23
  IF NOT EOF(1) THEN
   LINE INPUT #1, Text$(i%)
  ELSE
   Text$(i%) = ""
  END IF
  IF FileMode% = 1 AND LTRIM$(RTRIM$(Text$(i%))) = " EOF ۲" THEN EndOfFile% = 1
  IF EndOfFile% = 1 THEN Text$(i%) = ""
 NEXT i%
 CLOSE
 OPEN CMD$ FOR INPUT AS #1
 IF FileMode% = 1 THEN LINE INPUT #1, dummy$
END SUB 'ReadFile (StartLine!)

