include file.e
include graphics.e
include misc.e
include dfrntend.e

without warning

constant Version = "v1.0"

global bool PK,
	    Mode

function Parse(sequence BigThing, object Delimiter)
    integer temp
    sequence Strings
    sequence Remaining
    Strings = {}
    Remaining = trim(BigThing)
    
    while (atom(Delimiter) and find(Delimiter, Remaining)) or
	(sequence(Delimiter) and match(Delimiter, Remaining)) do
	
	if atom(Delimiter) then
	    temp = find(Delimiter, Remaining)
	else
	    temp = match(Delimiter, Remaining)
	end if
	Strings = append(Strings, Remaining[1..temp - 1])
	if atom(Delimiter) then
	    Remaining = trim(Remaining[temp + 1..length(Remaining)])
	else
	    Remaining = trim(Remaining[temp +
		length(Delimiter)..length(Remaining)])
	end if
    end while
    if compare(Remaining, "") then
	Strings = append(Strings, Remaining)
    end if
    return(Strings)
end function

function path_exist(sequence filename)
    sequence path
    if exist(filename) then
	return(TRUE)
    end if
    path = Parse(getenv("path"), ';')
    for i = 1 to length(path) do
	if exist(path[i] & "\\" & filename) then
	    return(TRUE)
	end if
    end for
    return(FALSE)
end function

PK = path_exist("PKUNZIP.EXE")

procedure DrawTitleBar(integer i)
    position(1, 1)
    text_color(15)
    bk_color(1)
    puts(2, repeat(' ', 80))
    position(1, 1)
    if i = 0 then
	Center("Dark Frontend Setup Wizard " & Version, 15, 7, 8)
    elsif i = 1 then
	Center("Dark Frontend Setup Wizard " & Version & " - Screen Test", 15, 7, 8)
    elsif i = 2 then
	Center("Thank you for using Dark Frontend Setup Wizard " & Version & "!", 15, 7, 8)
    elsif i = 3 then
	Center("Dark Frontend Setup Wizard " & Version & " - Cleaning Up Dark Dir", 15, 7, 8)
    elsif i = 4 then
	Center("Dark Frontend Setup Wizard " & Version & " - Setting Up Level", 15, 7, 8)
    end if
end procedure

procedure ScreenTests()
    integer TestFailed, fn
    sequence temp
    TestFailed = FALSE
    
    if text_rows(25) then end if
    DrawTitleBar(1)
    text_color(7)
    bk_color(0)
    puts(1, "\nDetecting OS...\n")
    if platform() != DOS32 and platform() != WIN32 then
	-- Support for WIN is not yet here... but will be soon. :)
	sound(500)
	text_color(12)
	puts(2, "Dark Frontend requires that you run it from DOS or WIN32.\n")
	puts(2, "Linux and any other versions of Euphoria are not supported\n")
	puts(2, "at this time.  Thank you.\n")
	sound(0)
	text_color(7)
	abort(1)
    end if
    if peek(VideoMem + 320) != 32 and peek(VideoMem + 320) != 0 and
	peek(VideoMem + 320) != 255 then
	
	TestFailed = TRUE
    end if
    puts(1, "Testing for color monitor (you DO have one... right?!?)...\n")
    if peek(VideoMem + 320) != 84 then
	TestFailed = TRUE
    end if
    if TestFailed then
	sound(500)
	text_color(12)
	puts(2, "Address &HB800 does not contain video memory.  Dark Frontend\n")
	puts(2, "requires video memory to run.  If you are running a DOS\n")
	puts(2, "emulator or are using a monochrome monitor, this could\n")
	puts(2, "explain this error. Run DFRNTEND in real DOS and with a color\n")
	puts(2, "system.\n")
	sound(0)
	text_color(7)
	abort(1)
    end if
    puts(1, "Video memory at [&HB800:0000-3999].  Yippee!\n")
    clear_screen()
    puts(1, "\nOpening DFRNTEND.INI... I hope it\'s in the current dir!\n")
    
    fn = open("DFRNTEND.INI", "rb")
    if fn = -1 then
	temp = SaveScreen()
	Options()
	RestoreScreen(temp)
	text_color(7)
	bk_color(0)
    else
	DarkDir = upper(INIRead(fn, "Main", "DarkDir"))
	LFDDir = upper(INIRead(fn, "Main", "LFDDir"))
	LevelsDir = upper(INIRead(fn, "Main", "LevelsDir"))
	if INIExist(fn, "Main", "Wallpaper") then
	    PaperFile = upper(INIRead(fn, "Main", "Wallpaper"))
	end if
	if not compare(DarkDir, "") or not compare(LFDDir, "") or not
	    compare(LevelsDir, "") then
	    
	    DarkDir = "C:\\DARK"
	    LFDDir = DarkDir & "\\LFD"
	    LevelsDir = DarkDir & "\\LEVELS"
	    PaperFile = "DFRNTEND.SRN"
	    temp = SaveScreen()
	    Options()
	    RestoreScreen(temp)
	    text_color(7)
	    bk_color(0)
	end if
	close(fn)
    end if
    puts(1, "Loading wallpaper...")
    Wallpaper = LoadSRN(PaperFile)
    if not compare(Wallpaper, {0}) then
	text_color(12)
	puts(2, "ERROR: " & PaperFile & " COULD NOT BE LOADED.  LOADING DEFAULT.\n")
	text_color(7)
	if Verbose then
	    puts(2, "Press any key to continue...\n")
	    while get_key() = -1 do end while
	end if
	PaperFile = "DFRNTEND.SRN"
	Wallpaper = LoadSRN(PaperFile)
    else
	text_color(10)
	puts(1, "Successful.\n")
	text_color(7)
    end if
end procedure

procedure DrawMenuStuff()
    text_color(15)
    bk_color(1)
    position(12, 28)
    puts(2, "      Clean Up DF Dir     ")
    position(14, 28)
    puts(2, "           Quit           ")
    if not PK then
	text_color(8)
    end if
    position(13, 28)
    puts(2, "   Setup A Zipped Level   ")
end procedure

function Menu()
    integer Pos, Key

    MakeWindow(27, 11, 54, 15, 15, 1)
    DrawMenuStuff()
    Pos = 0
    while 1 do
	if Pos = 0 then
	    bk_color(5)
	    text_color(10)
	    position(12, 28)
	    puts(2, "    " & 16 & "                 " & 17 & "   ")
	    text_color(14)
	    position(12, 34)
	    puts(2, "Clean Up DF Dir")
	elsif Pos = 1 then
	    bk_color(5)
	    text_color(10)
	    position(13, 28)
	    puts(2, " " & 16 & "                      " & 17 & " ")
	    if not PK then
		text_color(6)
	    else
		text_color(14)
	    end if
	    position(13, 31)
	    puts(2, "Setup A Zipped Level")
	elsif Pos = 2 then
	    bk_color(5)
	    text_color(10)
	    position(14, 28)
	    puts(2, "         " & 16 & "      " & 17 & "         ")
	    text_color(14)
	    position(14, 39)
	    puts(2, "Quit")
	end if
	Key = -1
	while Key = -1 do
	    Key = get_key()
	end while
	if Key = 27 and Pos != 2 then
	    Pos = 2
	    DrawMenuStuff()
	elsif Key = 27 and Pos = 2 then
	    text_color(7)
	    bk_color(0)
	    clear_screen()
	    DrawTitleBar(2)
	    text_color(7)
	    bk_color(0)
	    puts(2, "\n")
	    cursor(UNDERLINE_CURSOR)
	    return(3)
	elsif Key = 328 then
	    Pos -= 1
	    if Pos = -1 then
		Pos = 2
	    end if
	    DrawMenuStuff()
	elsif Key = 336 then
	    Pos += 1
	    if Pos = 3 then
		Pos = 0
	    end if
	    DrawMenuStuff()
	elsif Key = 13 then
	    if Pos = 2 then
		text_color(7)
		bk_color(0)
		clear_screen()
		DrawTitleBar(2)
		text_color(7)
		bk_color(0)
		puts(2, "\n")
		cursor(UNDERLINE_CURSOR)
		return(3)
	    elsif Pos = 1 then
		if not PK then
		    return(2)
		else
		    return(1)
		end if
	    elsif Pos = 0 then
		return(0)
	    end if
	end if
    end while
end function

function Longest(sequence Strings)
    integer Long
    Long = 0
    for i = 1 to length(Strings) do
	if length(Strings[i]) > Long then
	    Long = length(Strings[i])
	end if
    end for
    return(Long)
end function

procedure MessageBox(sequence Strings)
    integer x1, x2, y1, y2
    y1 = floor((25 - (length(Strings) + 4)) / 2)
    y2 = y1 + length(Strings) + 5
    x1 = floor((80 - (Longest(Strings) + 2)) / 2)
    x2 = x1 + Longest(Strings) + 3
    MakeWindow(x1, y1, x2, y2, 15, 1)
    for i = 1 to length(Strings) do
	position(y1 + i, 1)
	Center(Strings[i], 15, 15, 15)
    end for
    position(y2 - 3, 1)
    Center("͸", 14, 14, 14)
    position(y2 - 2, 1)
    Center("        ", 14, 14, 14)
    position(y2 - 1, 1)
    Center(";", 14, 14, 14)
    position(y2 - 2, 1)
    Center(17 & "    " & 16, 10, 10, 10)
    position(y2 - 2, 1)
    Center("OK", 15, 15, 15)
    while get_key() != 13 do end while
end procedure

constant ExcludeGOB = {"DARK.GOB", "SOUNDS.GOB", "SPRITES.GOB", "TEXTURES.GOB"}
function SortOneGOB(sequence path, sequence entry)
    integer temp, fn
    sequence Root, Files
    fn = -1
    
    if find('.', entry[D_NAME]) and not compare(upper(entry[D_NAME][find('.',
	entry[D_NAME])..length(entry[D_NAME])]), ".GOB") and not
	find(upper(entry[D_NAME]), ExcludeGOB) then
	
	Root = upper(entry[D_NAME][1..find('.', entry[D_NAME]) - 1])
	puts(2, "Locating child files for " & Root & "...\n")
	Files = {Root & ".GOB"}
	temp = exist(LevelsDir & "\\INI\\" & Root & ".INI")
	if temp then
	    fn = open(LevelsDir & "\\INI\\" & Root & ".INI", "rb")
	    puts(2, "Normal INI used.\n")
	else
	    temp = exist(LevelsDir & "\\MASTER.INI")
	    if temp then
		fn = open(LevelsDir & "\\MASTER.INI", "rb")
		puts(2, "Master INI used.\n")
	    end if
	end if
	if temp and INIExist(fn, Root & "-FILES", "") and
	    StartsAt(fn, Root & "-FILES", "File") != -1 then
	    
	    -- Level has an INI and it has a [GOBNAME-FILES] entry
	    puts(2, "INI found with all file entries for " & Root & "\n")
	    temp = StartsAt(fn, Root & "-FILES", "File")
	    while INIExist(fn, Root & "FILES", "File" & sprintf("%d", {temp}))
		do
		
		Files = append(Files,
		    INIRead(fn, Root & "FILES", "File" & sprintf("%d", {temp})))
		temp += 1
	    end while
	elsif temp then
	    -- Level has an INI with no [GOBNAME-FILES] entry
	    if INIExist(fn, Root, "") then
		puts(2, "INI found with essencial file entry for " & Root & "\n")
		if length(INIRead(fn, Root, "LFDName")) then
		    Files = append(Files, INIRead(fn, Root, "LFDName") & ".LFD")
		end if
		if length(INIRead(fn, Root, "CRAWLName")) then
		    Files = append(Files, INIRead(fn, Root, "CRAWLName") & ".LFD")
		end if
		temp = StartsAt(fn, Root, "Other")
		if temp != -1 then
		    while INIExist(fn, Root, "Other" & sprintf("%d", {temp})) do
			Files = append(Files, INIRead(fn, Root, "Other" &
			    sprintf("%d", {temp})))
			temp += 1
		    end while
		end if
	    else
		puts(2, "No entry found for " & Root & ", improvising...\n")
		if exist(path & "\\" & Root & ".LFD") then
		    Files = append(Files, Root & ".LFD")
		end if
	    end if
	    if exist(path & "\\" & Root & ".TXT") then
		Files = append(Files, Root & ".TXT")
	    end if
	    if exist(path & "\\" & Root & ".BAT") then
		Files = append(Files, Root & ".BAT")
	    end if
	else
	    -- Level does not have an INI
	    puts(2, "No INI found for " & Root & ", improvising...\n")
	    if exist(path & "\\" & Root & ".TXT") then
		Files = append(Files, Root & ".TXT")
	    end if
	    if exist(path & "\\" & Root & ".BAT") then
		Files = append(Files, Root & ".BAT")
	    end if
	    if exist(path & "\\" & Root & ".LFD") then
		Files = append(Files, Root & ".LFD")
	    end if
	end if
	-- Start copying Files
	puts(2, "Moving files for " & Root & " into a folder...\n")
	run("mkdir " & LevelsDir & "\\" & Root, 2)
	if fn != -1 then
	    close(fn)
	end if
	if exist(LevelsDir & "\\" & Root & "\\" & Root & ".INI") then
	    run("copy " & LevelsDir & "\\INI\\" & Root & ".INI " & LevelsDir
		& "\\" & Root, 2)
	end if
	temp = exist(LevelsDir & "\\INI\\" & Root & ".INI")
	if temp then
	    fn = open(LevelsDir & "\\INI\\" & Root & ".INI", "rb")
	else
	    temp = exist(LevelsDir & "\\MASTER.INI")
	    if temp then
		fn = open(LevelsDir & "\\MASTER.INI", "rb")
	    end if
	end if
	for i = 1 to length(Files) do
	    run("move " & path & "\\" & Files[i] & " " & LevelsDir & "\\"
		& Root & "\\", 2)
	    puts(2, "\n")   -- move will move the cursor back
	end for
	if Mode and exist(path & "\\*.*") then
	    run("move " & path & "\\*.* " & LevelsDir & "\\" & Root & "\\",
		2)
	    puts(2, "\n")   -- move will move the cursor back
	end if
	if fn != -1 then
	    temp = StartsAt(fn, Root & "-RENAME", "Ren")
	else
	    temp = -1
	end if
	if fn != -1 and temp != -1 then
	    puts(2, "Renaming some files to work with Dark Frontend...\n")
	    while INIExist(fn, Root & "-RENAME", "Ren" & sprintf("%d",
		{temp})) do
		    
		run("rename " & LevelsDir & "\\" & Root & "\\" &
		    INIRead(fn, Root & "-RENAME", "Ren" & sprintf("%d", {temp})) &
		    " " & INIRead(fn, Root & "-RENAME", "To" & sprintf("%d", {temp}))
		    , 2)
		temp += 1
	    end while
	end if
	if fn != -1 then
	    close(fn)
	end if
    end if
    return(0)
end function

procedure CleanDark()
    bk_color(0)
    clear_screen()
    DrawTitleBar(3)
    text_color(7)
    bk_color(0)
    puts(2, "\nWorking...\n")
    Mode = 0
    if walk_dir(DarkDir, routine_id("SortOneGOB"), FALSE) then end if   
    if Verbose then
	puts(2, "Press any key to continue...")
	while get_key() = -1 do end while
    end if
    DrawTitleBar(0)
    DrawWallpaper(FALSE)
    MessageBox({"NOTE: There may still be \"stray\" add-on files remaining in",
	"your Dark Forces dir.  There have been subfolders created in your",
	"Levels dir; these stray files can be moved to their appropriate",
	"subfolder, or they can remain in your Dark Forces dir if you wish.",
	"",
	"These files have been deemed unessencial for their add-on games to",
	"function normally.  If this is wrong, move each file to it's subfolder",
	"and read the section in DFRNTEND.TXT dealing with manually creating",
	"INIs for games.  Modify the game's/games' INI file to include this",
	"file in the game, as per the guidelines in DFRNTEND.TXT.",
	"",
	"Failing to do the above for essencial files missed by this Wizard",
	"will not stop add-on games from running, but they may lack features",
	"until the file(s) are correctly added to the game's/games' INI file(s)."})
end procedure

procedure Destroy(sequence path, sequence entry)
    run("del " & path & "\\" & entry[D_NAME], 2)
end procedure

procedure deldir(sequence path)
    if walk_dir(path, routine_id("Destroy"), FALSE) then end if   
    run("rmdir " & path, 2)
end procedure

procedure SetupLevel()
    integer return_code
    sequence Zip
    object tempfolder
    
    MakeWindow(9, 11, 72, 14, 15, 1)
    text_color(14)
    position(12, 11)
    puts(2, "ZIP Filename:")
    position(13, 11)
    text_color(7)
    bk_color(0)
    puts(2, repeat(' ', 60))
    Zip = LimitInput("", 11, 13, 70, TRUE)
    if length(Zip) = 0 then
	return
    end if  
    if not exist(Zip) then
	MessageBox({"The ZIP file, ",
	    "",
	    Zip,
	    "",
	    "could not be located.  Make sure the path",
	    "and filename are correct and try again."})
	return
    end if
    
    bk_color(0)
    clear_screen()
    DrawTitleBar(4)
    text_color(7)
    bk_color(0)
    puts(2, "\nLooking up environment variable for temporary directory...\n")
    tempfolder = getenv("temp")
    if atom(tempfolder) then
	tempfolder = getenv("tmp")
    end if
    if atom(tempfolder) then
	tempfolder = getenv("windir")
	if not atom(tempfolder) then
	    tempfolder &= "\\temp"
	end if
    end if
    if atom(tempfolder) then
	tempfolder = getenv("systemroot")
	if not atom(tempfolder) then
	    tempfolder &= "\\temp"
	end if
    end if
    if atom(tempfolder) then
	tempfolder = LevelsDir
    end if
    puts(2, "Using " & tempfolder & "\\DFRNTEND.\n")
    run("mkdir " & tempfolder & "\\DFRNTEND.", 2)
    return_code = run_prog("pkunzip.exe -o " & Zip & " " & tempfolder & "\\DFRNTEND.", 2)
    if Verbose then
	puts(2, "Press any key to continue...")
	while get_key() = -1 do end while
    end if
    clear_screen()
    DrawTitleBar(4)
    text_color(7)
    bk_color(0)
    if return_code then
	puts(2, "\nExtract FAILED!\n")
	deldir(tempfolder & "\\DFRNTEND.")
	while get_key() = -1 do end while
	return
    else
	puts(2, "\nExtract successful.\n")
    end if
    puts(2, "Picking any GOBs to sort...\n")
    Mode = 1
    if walk_dir(tempfolder & "\\DFRNTEND.", routine_id("SortOneGOB"), FALSE)
	then end if
    deldir(tempfolder & "\\DFRNTEND.")
    if Verbose then
	puts(2, "Press any key to continue...")
	while get_key() = -1 do end while
    end if
    DrawTitleBar(0)
end procedure

integer temp

ScreenTests()
cursor(NO_CURSOR)
DrawTitleBar(0)
while 1 do
    DrawWallpaper(FALSE)
    temp = Menu()
    if temp = 0 then
	CleanDark()
    elsif temp = 1 then
	SetupLevel()
    elsif temp = 2 then
	MessageBox({"Dark Frontend Setup Wizard cannot find PKUNZIP.EXE in the",
	    "current directory or path.  This file is needed to unpack your game.", 
	    "If you do not have PKUNZIP.EXE, you can simply use any other unzipper",
	    "to unzip the level into your DARK dir and use this Wizard's",
	    "\"Clean Up DF Dir\" feature."})
    else
	abort(0)
    end if
end while
