include get.e
include graphics.e
include misc.e
include dfrntend.e

global constant Version = "v2.5",
		NumTitles = 15

sequence DFGameData, cmd
DarkDir = "C:\\DARK"
LFDDir = "C:\\DARK\\LFD"
LevelsDir = "C:\\DARK\\LEVELS"

DFGameData = {{"Dark Forces", {0}, "", "", 0}}
cmd = command_line()

without warning

function CMDFind(sequence param)
    sequence thingys
    thingys = {"", "/", "-"}

    for j = 1 to length(thingys) do
	for i = 1 to length(cmd) do
	    if not compare(trim(upper(cmd[i])), thingys[j] &
		trim(upper(param))) then
		
		return i
	    end if
	end for
    end for

    return 0
end function

procedure DrawTitleBar(integer Num)
    position(1, 1)
    text_color(15)
    bk_color(1)
    puts(2, repeat(' ', 80))
    position(1, 1)
    if Num = 0 then
	Center("Dark Frontend " & Version, 15, 7, 8)
    elsif Num = 1 then
	Center("Dark Frontend " & Version & " - Pre-GUI Tests", 15, 7, 8)
    elsif Num = 2 then
	Center("Dark Frontend " & Version & " - Loading Files", 15, 7, 8)
    elsif Num = 3 then
	Center("Thank you for using Dark Frontend " & Version & "!", 15, 7, 8)
    elsif Num = 4 then
	Center("Dark Frontend " & Version & " - Preparing to run Dark Forces",
	    15, 7, 8)
    elsif Num = 5 then
	Center("Dark Frontend " & Version & " - Memory Check", 15, 7, 8)
    end if
end procedure

function GetDirs(sequence path_name, sequence entry)
    if find('d', entry[D_ATTRIBUTES]) and (exist(LevelsDir & "\\" &
	entry[D_NAME] & "\\" & entry[D_NAME] & ".INI") or exist(LevelsDir &
	 "\\" & entry[D_NAME] & "\\" & entry[D_NAME] & ".GOB")) then
	
	DFGameData = append(DFGameData, {"", entry[D_NAME], "", ""})
    end if
    return 0
end function

function lesslen(sequence a, sequence b)
    if length(a) < length(b) then
	return length(a)
    end if
    return length(b)
end function

procedure SortGames()
    sequence temp

    for i = 1 to length(DFGameData) do
	if not compare(DFGameData[i][GOBName], {0}) then
	    temp = DFGameData[i]
	    DFGameData[i] = DFGameData[1]
	    DFGameData[1] = temp
	    exit
	end if
    end for
    for i = length(DFGameData) to 2 by -1 do
	for j = 2 to i - 1 do
	    if compare(trim(DFGameData[j][GameName]),
		trim(DFGameData[j + 1][GameName])) then
		
		for k = 1 to lesslen(trim(DFGameData[j][GameName]),
		    trim(DFGameData[j + 1][GameName]))  do
		    
		    if lower(DFGameData[j][GameName][k]) >
			lower(DFGameData[j + 1][GameName][k]) then
			
			temp = DFGameData[j]
			DFGameData[j] = DFGameData[j + 1]
			DFGameData[j + 1] = temp
			exit
		    end if
		    if lower(DFGameData[j][GameName][k]) <
			lower(DFGameData[j + 1][GameName][k]) then
			
			exit
		    end if
		    if k = lesslen(trim(DFGameData[j][GameName]),
			trim(DFGameData[j + 1][GameName])) then
			
			temp = DFGameData[j]
			DFGameData[j] = DFGameData[j + 1]
			DFGameData[j + 1] = temp
		    end if
		end for
	    end if
	end for
    end for
end procedure

procedure ScreenTests()
    object temp, temp2
    integer TestFailed, fn, k, fn2
    
    if text_rows(25) then end if
    TestFailed = FALSE
    DrawTitleBar(1)
    text_color(7)
    bk_color(0)
    if platform() != DOS32 and platform() != WIN32 then
	-- Support for WIN is not yet here... but will be soon. :)
	sound(500)
	text_color(12)
	puts(2, "Dark Frontend requires that you run it from DOS or WIN32.\n")
	puts(2, "Linux and any other versions of Euphoria are not supported.\n")
	puts(2, "Thank you.\n")
	sound(0)
	text_color(7)
	abort(1)
    end if
    fn = open("DFRNTEND.INI", "rb")
    if fn = -1 then
	temp = SaveScreen()
	Options()
	RestoreScreen(temp)
	text_color(7)
	bk_color(0)
    else
	DarkDir = upper(INIRead(fn, "Main", "DarkDir"))
	LFDDir = upper(INIRead(fn, "Main", "LFDDir"))
	LevelsDir = upper(INIRead(fn, "Main", "LevelsDir"))
	if INIExist(fn, "Main", "Wallpaper") then
	    PaperFile = upper(INIRead(fn, "Main", "Wallpaper"))
	end if
	if not compare(DarkDir, "") or not compare(LFDDir, "") or not
	    compare(LevelsDir, "") then
	    
	    DarkDir = "C:\\DARK"
	    LFDDir = DarkDir & "\\LFD"
	    LevelsDir = DarkDir & "\\LEVELS"
	    temp = SaveScreen()
	    Options()
	    RestoreScreen(temp)
	    text_color(7)
	    bk_color(0)
	end if
	close(fn)
    end if
    if peek(VideoMem + 160) != 32 and peek(VideoMem + 160) != 0 and
	peek(VideoMem + 160) != 255 then
	
	TestFailed = TRUE
    end if
    text_color(0)
    position(2, 1)
    puts(1, "")
    if peek(VideoMem + 160) != 254 then
	TestFailed = TRUE
    end if
    if TestFailed then
	position(2, 1)
	sound(500)
	text_color(12)
	puts(2, "Address &HB800 does not contain video memory.  Dark Frontend\n")
	puts(2, "requires video memory to run.  If you are running a DOS\n")
	puts(2, "emulator or are using a monochrome monitor, this could\n")
	puts(2, "explain this error. Run DFRNTEND in real DOS and with a color\n")
	puts(2, "system.\n")
	sound(0)
	text_color(7)
	abort(1)
    end if
    position(1, 1)
    text_color(7)
    Wallpaper = LoadSRN(PaperFile)
    if not compare(Wallpaper, {0}) then
	text_color(12)
	puts(2, "ERROR: " & PaperFile & " COULD NOT BE LOADED.  LOADING DEFAULT.\n")
	text_color(7)
	if Verbose then
	    puts(2, "Press any key to continue...\n")
	    while get_key() = -1 do end while
	end if
	PaperFile = "DFRNTEND.SRN"
	Wallpaper = LoadSRN(PaperFile)
    end if
    if not compare(Wallpaper, {0}) then
	if not compare(get_position(), {25, 1}) then
	    scroll(1, 2, 25)
	    position(24, 1)
	end if
	text_color(12)
	printf(2, "Ack!  %s could not be found!  I'll make do with a solid" &
	    " \'paper.\n", {PaperFile})
	text_color(7)
	Wallpaper = {}
	for i = 1 to (80 * 24) do
	    Wallpaper &= {176, 28}
	end for
    end if
    DrawTitleBar(2)
    DrawWallpaper(FALSE)
    MakeWindow(5, 11, 76, 13, 15, 1)
    text_color(14)
    bk_color(1)
    position(12, 7)
    puts(1, "Getting game list...")
    if walk_dir(LevelsDir, routine_id("GetDirs"), FALSE) then end if
    
    temp = get_position()
    fn2 = open(LevelsDir & "\\MASTER.INI", "rb")
    for j = 1 to length(DFGameData) do
	if compare(DFGameData[j][GOBName], {0}) then
	    position(12, 7)
	    printf(1, "Opening and reading %s...", {DFGameData[j][GOBName]})
	    puts(1, repeat(' ', 68 - (23 + length(DFGameData[j][GOBName]))))
	    fn = open(LevelsDir & "\\" & DFGameData[j][GOBName] & "\\" &
		DFGameData[j][GOBName] & ".INI", "rb")
	    if fn != -1 then -- If it is -1, there is no INI, just a GOB.
		DFGameData[j][GameName] = INIRead(fn, DFGameData[j][GOBName],
		    "GameName")
		DFGameData[j][LFDName] = INIRead(fn, DFGameData[j][GOBName],
		    "LFDName")
		DFGameData[j][CRAWLName] = INIRead(fn, DFGameData[j][GOBName],
		    "CRAWLName")
		temp = INIExist(fn, DFGameData[j][GOBName], "Other0")
		if not compare(temp, 0) then
		    k = 1
		else
		    k = 0
		end if
		while INIExist(fn, DFGameData[j][GOBName], "Other" &
		    sprintf("%d", {k})) = 1 do
		    
		    DFGameData[j] &= {INIRead(fn, DFGameData[j][GOBName],
			"Other" & sprintf("%d", {k}))}
		    k += 1
		end while
		close(fn)
		if not compare(DFGameData[j][GameName], "") then
		    DFGameData[j][GameName] = DFGameData[j][GOBName] & " - No title"
		end if
	    elsif fn2 != -1 then
		DFGameData[j][GameName] = MasterINIRead(fn2, DFGameData[j][GOBName],
		    "GameName")
		DFGameData[j][LFDName] = MasterINIRead(fn2, DFGameData[j][GOBName],
		    "LFDName")
		DFGameData[j][CRAWLName] = MasterINIRead(fn2, DFGameData[j][GOBName],
		    "CRAWLName")
		temp = MasterINIExist(fn2, DFGameData[j][GOBName], "Other0")
		if not compare(temp, 0) then
		    k = 1
		else
		    k = 0
		end if
		while MasterINIExist(fn2, DFGameData[j][GOBName], "Other" &
		    sprintf("%d", {k})) = 1 do
		    
		    DFGameData[j] &= {MasterINIRead(fn2, DFGameData[j][GOBName],
			"Other" & sprintf("%d", {k}))}
		    k += 1
		end while
		if not compare(DFGameData[j][GameName], "") then
		    DFGameData[j][GameName] = DFGameData[j][GOBName] & " - No Info Available"
		end if
	    else
		DFGameData[j][GameName] = DFGameData[j][GOBName] & " - No Info Available"
	    end if
	end if
    end for
    if fn2 != -1 then
	close(fn2)
    end if
    temp2 = 1
    while temp2 <= length(DFGameData) do
	if length(DFGameData[temp2][GameName]) > 70 then
	    DFGameData[temp2][GameName] = DFGameData[temp2][GameName][1..70]
	end if
	if not compare(DFGameData[temp2][GameName], "") then
	    DFGameData = DFGameData[1..temp2 - 1] &
		DFGameData[temp2 + 1..length(DFGameData)]
	    temp2 -= 1
	end if
	temp2 += 1
    end while
    position(12, 7)
    puts(1, "Sorting game list alphabetically...")
    SortGames()
    if not compare(get_position(), {25, 1}) then
	scroll(1, 2, 25)
	position(24, 1)
    end if
    position(12, 7)
    puts(1, "Checking for Dark Frontend crash...")
    if exist(LFDDir & "\\DFBRIEF.DFE") then
	if not compare(get_position(), {25, 1}) then
	    scroll(1, 2, 25)
	    position(24, 1)
	end if
	position(12, 7)
	puts(1, "Restoring DFBRIEF.LFD...")
	if exist(LFDDir & "\\DFBRIEF.LFD") then
	    run("del " & LFDDir & "\\DFBRIEF.LFD", 2)
	end if
	run("rename " & LFDDir & "\\DFBRIEF.DFE " & LFDDir & "\\DFBRIEF.LFD", 2)
    end if
    if exist(LFDDir & "\\FTEXTCRA.DFE") then
	if not compare(get_position(), {25, 1}) then
	    scroll(1, 2, 25)
	    position(24, 1)
	end if
	position(12, 7)
	puts(1, "Restoring FTEXTCRA.LFD...")
	if exist(LFDDir & "\\FTEXTCRA.LFD") then
	    run("del " & LFDDir & "\\FTEXTCRA.LFD", 2)
	end if
	run("rename " & LFDDir & "\\FTEXTCRA.DFE " & LFDDir & "\\FTEXTCRA.LFD", 2)
    end if
    if not compare(get_position(), {25, 1}) then
	scroll(1, 2, 25)
	position(24, 1)
    end if
    if not compare(get_position(), {25, 1}) then
	scroll(1, 2, 25)
	position(24, 1)
    end if
    position(12, 7)
    puts(1, "Done!  Ready to bring up the menu-thingy...")
end procedure

procedure DrawOptions(integer x1, integer y1, integer x2)
    text_color(7)
    bk_color(1)
    position(y1 + 1, x1 + 1)
    puts(2, "͸ ")
    position(y1 + 1, 33)
    puts(2, "͸ ")
    text_color(0)
    position(y1 + 1, x2 - 12)
    puts(2, "͸")
    text_color(7)
    position(y1 + 2, x1 + 1)
    puts(2, "          ")
    position(y1 + 2, 33)
    puts(2, "              ")
    text_color(0)
    position(y1 + 2, x2 - 12)
    puts(2, "          ")
    text_color(10)
    position(y1 + 2, x1 + 3)
    puts(2, 17 & "      " & 16)
    position(y1 + 2, 35)
    puts(2, 17 & "         " & 16)
    position(y1 + 2, x2 - 10)
    puts(2, 17 & "      " & 16)
    text_color(15)
    position(y1 + 2, x1 + 5)
    puts(2, "Play")
    position(y1 + 2, 37)
    puts(2, "Options")
    position(y1 + 2, x2 - 8)
    puts(2, "Quit")
    text_color(7)
    position(y1 + 3, x1 + 1)
    puts(2, "; ")
    position(y1 + 3, 33)
    puts(2, "; ")
    text_color(0)
    position(y1 + 3, x2 - 12)
    puts(2, ";")
end procedure

procedure DrawNames(integer Start, integer x1, integer y1, integer x2)
    text_color(9)
    bk_color(1)
    for i = Start to Start + NumTitles - 1 do
	if length(DFGameData) >= i then
	    position(y1 + (i - Start), x1 - 1)
	    puts(2, " " & trim(DFGameData[i][GameName]) & repeat(' ', x2 - x1 -
		length(trim(DFGameData[i][GameName])) + 1))
	end if
    end for
end procedure

function MainWindow()
    integer WindWidth, x1, y1, x2, y2, j, Game, Key
    WindWidth = 0
    
    for i = 1 to length(DFGameData) do
	if length(trim(DFGameData[i][GameName])) > WindWidth then
	    WindWidth = length(trim(DFGameData[i][GameName])) + 1
	end if
    end for
    if WindWidth < 39 then
	WindWidth = 39
    end if
    x1 = floor((80 - (WindWidth + 4)) / 2) + 1
    y1 = floor((25 - (6 + NumTitles)) / 2) + 1
    x2 = x1 + WindWidth + 2
    y2 = 25 - y1
    if floor(NumTitles / 2) != NumTitles / 2 then
	y2 += 1
    end if
    MakeWindow(x1, y1, x2, y2, 15, 1)
    text_color(15)
    bk_color(1)
    position(y1 + 4, x1)
    puts(2, "" & repeat('', x2 - x1 - 10))
    text_color(11)
    position(y1 + 4, x2 - 9)
    puts(2, "")
    text_color(3)
    position(y1 + 4, x2 - 8)
    puts(2, "")
    text_color(9)
    position(y1 + 4, x2 - 7)
    puts(2, repeat('', 7) & "")
    j = 0
    DrawOptions(x1, y1, x2)
    DrawNames(1, x1 + 2, y1 + 5, x2 - 1)
    Game = 1
    Key = 0
    while Key != -1 do
	Key = get_key()
    end while
    -- In case user just returned from a DF error message, clear the buffer.
    while 1 do
	if j = 0 then
	    text_color(14)
	    bk_color(1)
	    position(y1 + 1, x1 + 1)
	    puts(2, "͸ ")
	    position(y1 + 2, x1 + 1)
	    puts(2, " ")
	    text_color(10)
	    puts(2, {17})
	    text_color(15)
	    puts(2, " PLAY ")
	    text_color(10)
	    puts(2, {16})
	    text_color(14)
	    puts(2, "  ")
	    position(y1 + 3, x1 + 1)
	    puts(2, "; ")
	elsif j = 1 then
	    text_color(14)
	    bk_color(1)
	    position(y1 + 1, 33)
	    puts(2, "͸ ")
	    position(y1 + 2, 33)
	    puts(2, " ")
	    text_color(10)
	    puts(2, {17})
	    text_color(15)
	    puts(2, " OPTIONS ")
	    text_color(10)
	    puts(2, {16})
	    text_color(14)
	    puts(2, "  ")
	    position(y1 + 3, 33)
	    puts(2, "; ")
	elsif j = 2 then
	    text_color(14)
	    bk_color(1)
	    position(y1 + 1, x2 - 12)
	    puts(2, "͸")
	    position(y1 + 2, x2 - 12)
	    puts(2, " ")
	    text_color(10)
	    puts(2, {17})
	    text_color(15)
	    puts(2, " QUIT ")
	    text_color(10)
	    puts(2, {16})
	    text_color(14)
	    puts(2, " ")
	    position(y1 + 3, x2 - 12)
	    puts(2, ";")
	end if
	text_color(14)
	bk_color(5)
	if Game < floor(NumTitles / 2) + 1 then
	    position(y1 + 4 + Game, x1 + 1)
	elsif Game > length(DFGameData) - floor(NumTitles / 2) then
	    position(y2 - (length(DFGameData) - Game) - 1, x1 + 1)
	else
	    position(y1 + 5 + floor(NumTitles / 2), x1 + 1)
	end if
	puts(2, " " & trim(DFGameData[Game][GameName]) & repeat(' ', x2 - x1 -
	    length(trim(DFGameData[Game][GameName])) - 2))
	Key = -1
	while Key = -1 do
	    Key = get_key()
	end while
	if Key = 331 then
	    j -= 1
	    DrawOptions(x1, y1, x2)
	    if j = -1 then
		j = 2
	    end if
	elsif Key = 333 then
	    j += 1
	    DrawOptions(x1, y1, x2)
	    if j = 3 then
		j = 0
	    end if
	elsif Key = 328 then
	    Game -= 1
	    if Game < 1 then
		Game = 1
	    end if
	    if Game < floor(NumTitles / 2) + 1 then
		DrawNames(1, x1 + 2, y1 + 5, x2 - 1)
	    elsif Game > length(DFGameData) - floor(NumTitles / 2) then
		DrawNames(length(DFGameData) - NumTitles + 1, x1 + 2, y1 + 5,
		    x2 - 1)
	    else
		DrawNames(Game - floor(NumTitles / 2), x1 + 2, y1 + 5, x2- 1)
	    end if
	elsif Key = 336 then
	    Game += 1
	    if Game > length(DFGameData) then
		Game = length(DFGameData)
	    end if
	    if Game < floor(NumTitles / 2) + 1 then
		DrawNames(1, x1 + 2, y1 + 5, x2 - 1)
	    elsif Game > length(DFGameData) - floor(NumTitles / 2) then
		DrawNames(length(DFGameData) - NumTitles + 1, x1 + 2, y1 + 5,
		    x2 - 1)
	    else
		DrawNames(Game - floor(NumTitles / 2), x1 + 2, y1 + 5, x2- 1)
	    end if
	elsif Key = 329 then
	    Game -= 15
	    if Game < 1 then
		Game = 1
	    end if
	    if Game < floor(NumTitles / 2) + 1 then
		DrawNames(1, x1 + 2, y1 + 5, x2 - 1)
	    elsif Game > length(DFGameData) - floor(NumTitles / 2) then
		DrawNames(length(DFGameData) - NumTitles + 1, x1 + 2, y1 + 5,
		    x2 - 1)
	    else
		DrawNames(Game - 7, x1 + 2, y1 + 5, x2- 1)
	    end if
	elsif Key = 337 then
	    Game += 15
	    if Game > length(DFGameData) then
		Game = length(DFGameData)
	    end if
	    if Game < floor(NumTitles / 2) + 1 then
		DrawNames(1, x1 + 2, y1 + 5, x2 - 1)
	    elsif Game > length(DFGameData) - floor(NumTitles / 2) then
		DrawNames(length(DFGameData) - NumTitles + 1, x1 + 2, y1 + 5,
		    x2 - 1)
	    else
		DrawNames(Game - 7, x1 + 2, y1 + 5, x2- 1)
	    end if
	elsif Key = 27 then
	    if j != 2 then
		j = 2
		DrawOptions(x1, y1, x2)
	    else
		text_color(7)
		bk_color(0)
		clear_screen()
		DrawTitleBar(3)
		text_color(7)
		bk_color(0)
		puts(2, "\n")
		cursor(UNDERLINE_CURSOR)
		abort(0)
	    end if
	elsif Key = 13 or Key = 32 then
	    if j = 2 then
		text_color(7)
		bk_color(0)
		clear_screen()
		DrawTitleBar(3)
		text_color(7)
		bk_color(0)
		puts(2, "\n")
		cursor(UNDERLINE_CURSOR)
		abort(0)
	    elsif j = 1 then
		DrawWallpaper(FALSE)
		return(-1)
	    elsif j = 0 then
		DrawWallpaper(FALSE)
		return(Game)
	    end if
	elsif Key = 303 then    -- ALT - V
	    return(-2)
	elsif Key = 306 then    -- ALT - M
	    return(-3)
	end if
    end while
end function

procedure PlayGame(integer Game)
    bk_color(0)
    clear_screen()
    DrawTitleBar(4)
    text_color(7)
    puts(2, "\n")
    cursor(UNDERLINE_CURSOR)
    if not compare(DFGameData[Game][GOBName], {0}) then
	if chdir(DarkDir) then end if
	if run_prog("dark.exe -shots", 0) then end if
	if chdir(LevelsDir) then end if
	if Verbose then
	    puts(2, "Press any key to continue...")
	    while get_key() = -1 do end while
	end if
	cursor(NO_CURSOR)
	DrawTitleBar(0)
	DrawWallpaper(FALSE)
	return
    end if
    if chdir(LevelsDir & "\\" & trim(DFGameData[Game][GOBName])) then end if
    run("copy " & trim(DFGameData[Game][GOBName] & ".GOB " & DarkDir), 2)
    if chdir(LFDDir) then end if
    if compare(trim(DFGameData[Game][LFDName]), "") then
	run("rename DFBRIEF.LFD DFBRIEF.DFE", 2)
	run("copy " & LevelsDir & "\\" & DFGameData[Game][GOBName] & "\\" &
	    trim(DFGameData[Game][LFDName]) & ".LFD .", 2)
	run("rename " & trim(DFGameData[Game][LFDName]) & ".LFD DFBRIEF.LFD", 2)
    end if
    if compare(trim(DFGameData[Game][CRAWLName]), "") then
	run("rename FTEXTCRA.LFD FTEXTCRA.DFE", 2)
	run("copy " & LevelsDir & "\\" & DFGameData[Game][GOBName] & "\\" &
	    trim(DFGameData[Game][CRAWLName]) & ".LFD .", 2)
	run("rename " & trim(DFGameData[Game][CRAWLName]) & ".LFD FTEXTCRA.LFD",
	    2)
    end if
    if chdir(LevelsDir & "\\" & trim(DFGameData[Game][GOBName])) then end if
    for i = Others to length(DFGameData[Game]) do
	run("copy " & DFGameData[Game][i] & " " & DarkDir, 2)
    end for
    if chdir(DarkDir) then end if
    if run_prog("dark -u" & trim(DFGameData[Game][GOBName] & ".GOB - shots"),
	2) then end if
    run("del " & trim(DFGameData[Game][GOBName] & ".GOB"), 2)
    for i = Others to length(DFGameData[Game]) do
	run("del " & DFGameData[Game][i], 2)
    end for
    if chdir(LFDDir) then end if
    if compare(trim(DFGameData[Game][LFDName]), "") then
	run("del DFBRIEF.LFD", 2)
	run("rename DFBRIEF.DFE DFBRIEF.LFD", 2)
    end if
    if compare(trim(DFGameData[Game][CRAWLName]), "") then
	run("del FTEXTCRA.LFD", 2)
	run("rename FTEXTCRA.DFE FTEXTCRA.LFD", 2)
    end if
    if chdir(LevelsDir) then end if
    if Verbose then
	puts(2, "Press any key to continue...")
	while get_key() = -1 do end while
    end if
    cursor(NO_CURSOR)
    DrawTitleBar(0)
    DrawWallpaper(FALSE)
end procedure

integer hmm

cursor(NO_CURSOR)
clear_screen()
ScreenTests()
DrawTitleBar(FALSE)
while 1 do
    DrawWallpaper(FALSE)
    hmm = MainWindow()
    if hmm = -1 then
	Options()
	Wallpaper = LoadSRN(PaperFile)
	if not compare(Wallpaper, {0}) then
	    PaperFile = "DFRNTEND.SRN"
	    Wallpaper = LoadSRN(PaperFile)
	end if
    elsif hmm = -2 then
	DrawWallpaper(TRUE)
	while get_key() = -1 do end while
	DrawTitleBar(0)
    elsif hmm = -3 then
	text_color(7)
	bk_color(0)
	clear_screen()
	DrawTitleBar(5)
	text_color(7)
	bk_color(0)
	puts(2, "\nDark Forces requires 7,024K of memory.\n")
	run("mem /p", 2) -- Display memory
	while get_key() = -1 do end while
	DrawTitleBar(0)
	DrawWallpaper(FALSE)
    else
	PlayGame(hmm)
    end if
end while
