'DFRNTEND.BAS
 'SUB and FUNCTION declarations
 DECLARE SUB Center (text$)
 DECLARE SUB ClearWindow (x1%, y1%, x2%, y2%)
 DECLARE SUB DrawBackground ()
 DECLARE SUB DrawNames (Start%, x1%, y1%, x2%)
 DECLARE SUB DrawOpStuff ()
 DECLARE SUB DrawOptions (x1%, y1%)
 DECLARE SUB DrawTitleBar (num%)
 DECLARE FUNCTION INIRead$ (FileNum%, Section$, Key$)
 DECLARE FUNCTION LesserLEN% (i$, j$)
 DECLARE FUNCTION LimitInput$ (num%)
 DECLARE SUB MakeWindow (x1%, y1%, x2%, y2%, c1%, c2%)
 DECLARE FUNCTION MainWindow% ()
 DECLARE SUB Options ()
 DECLARE SUB PlayGame (Number%)
 DECLARE SUB SortGames ()
 DECLARE SUB Tests ()
 DECLARE SUB WriteFile ()
 'Current version of Dark Frontend
 CONST verNum$ = "v1.0"
 'Boolean Constants
 CONST TRUE = -1
 CONST FALSE = 0
 'Types
 TYPE TypeData
  GameName AS STRING * 50
  GOBName AS STRING * 8
  LFDName AS STRING * 8
  CRAWLName AS STRING * 8
  OtherNum AS INTEGER
  '0-9 to DARKDir$
  Others0 AS STRING * 12
  Others1 AS STRING * 12
  Others2 AS STRING * 12
  Others3 AS STRING * 12
  Others4 AS STRING * 12
  Others5 AS STRING * 12
  Others6 AS STRING * 12
  Others7 AS STRING * 12
  Others8 AS STRING * 12
  Others9 AS STRING * 12
 END TYPE
 'Variables
 DIM SHARED DarkDir$, LFDDir$, LevelsDir$, ListName$, LastRecord%, NumTitles%, ErrSpec%
 DarkDir$ = "C:\DARK"
 LFDDir$ = "C:\DARK\LFD"
 LevelsDir$ = "C:\DARK\LEVELS"
 ListName$ = "MAINLIST.INI"
 DIM SHARED DFGameData(99) AS TypeData
 DFGameData(0).GameName$ = "Dark Forces"
 DFGameData(0).GOBName$ = "۲Dark"
 NumTitles% = 10

 'Turn the cursor off
 LOCATE 1, 1, 0
 'Clear the screen
 CLS
 'Test for proper video card (monochrome uses &HB000 instead of &HB800)
 Tests
 'Draw the title and the version number in a blue bar
 DrawTitleBar 0
 'Draw the wallpaper
 DrawBackground
 'Sort Records
 SortGames
 'Make the Main Window
 DO
  dowhat% = MainWindow
  IF dowhat% = -1 THEN
   Options
  ELSE
   PlayGame dowhat%
  END IF
 LOOP
END 'DFRNTEND.BAS

nofile:
 BEEP
 SELECT CASE ERR
  CASE 76
   PRINT "A game sub-dir does not exist.  Make sure there are no mis-types in"
   PRINT "the list file."
  CASE 75
   SELECT CASE ErrSpec%
    CASE 32767
     PRINT "A disk error occurred.  DFRNTEND.INI could not be accessed."
    CASE ELSE
     PRINT "A disk error occurred.  The current path or the file could not be"
     PRINT "accessed properly."
   END SELECT
  CASE 72
   SELECT CASE ErrSpec%
    CASE 32767
     PRINT "A floppy disk error occurred.  DFRNTEND.INI could not be accessed."
    CASE ELSE
     PRINT "A floppy disk error occurred.  This disk is faulty.  Could not read"
     PRINT "file successfully."
   END SELECT
  CASE 71
   PRINT "The drive is not ready.  Make sure the disk is in and run DFRNTEND"
   PRINT "again."
  CASE 70
   SELECT CASE ErrSpec%
    CASE 32767
     PRINT "Access was denied to this computer to open DFRNTEND.INI.  Please try"
     PRINT "installing this program locally or enable read access on the remote"
     PRINT "computer."
    CASE ELSE
     PRINT "Access was denied to this computer to open the file.  Please try"
     PRINT "installing this program locally or enable read access on the remote"
     PRINT "computer."
   END SELECT
  CASE 55
   SELECT CASE ErrSpec%
    CASE 32767
     PRINT "DFRNEND.INI is already in use by another application.  Close it and"
     PRINT "try again."
    CASE ELSE
     PRINT "This file is already in use by another application.  Close it and"
     PRINT "try again."
   END SELECT
  CASE 62
   SELECT CASE ErrSpec%
    CASE 32767
     PRINT "DFRNTEND.INI is too short.  Repair."
    CASE ELSE
     PRINT "File is too short.  Please make sure all fields are present."
   END SELECT
  CASE 50
   SELECT CASE ErrSpec%
    CASE 32767
     PRINT "DFRNTEND.INI is formatted wrong.  Remove all comments, etc. and try again."
    CASE ELSE
     PRINT "File is formatted wrong.  Remove all comments, etc. and try again."
   END SELECT
  CASE 9
   PRINT "Too many entries.  Shorten or make alternate list."
  CASE 53
   SELECT CASE ErrSpec%
    CASE 32767
     PRINT "DFRNTEND.INI not found."
    CASE ELSE
     PRINT "File not found."
   END SELECT
  CASE 77
   PRINT "Unexpected End Of File.  Missing INI Section."
  CASE 78
   PRINT "Unexpected End Of File.  Missing INI Key."
  CASE ELSE
   PRINT "Unknown Run-Time Error #"; STR$(ERR); "."
 END SELECT
 PRINT "File: ";
 IF ErrSpec% = 32767 THEN PRINT "DFRNTEND.INI"
 IF ErrSpec% < 256 AND ErrSpec% > 0 THEN PRINT RTRIM$(DFGameData(ErrSpec%).GOBName$); "\"; RTRIM$(DFGameData(ErrSpec%).GOBName$); ".INI"
 IF ErrSpec% = 30000 THEN PRINT ListName$
END 'nofile

SUB Center (text$)
 'Screen width minus the length of the text gives you the free spaces on both
 'sides of the text.  Divide that by two and round it and it gives you the
 'free space to the left or right, which you can use with TAB or LOCATE.
 LOCATE CSRLIN, INT((80 - LEN(text$)) / 2)
 PRINT text$
END SUB 'Center (text$)

SUB ClearWindow (x1%, y1%, x2%, y2%)
 COLOR 12, 1
 'Change the window area to the background
 FOR i% = y1% TO y2% + 1
  LOCATE i%, x1%
  PRINT STRING$(x2% - x1% + 3, "");
 NEXT i%
END SUB 'ClearWindow (x1%, y1%, x2%, y2%)

SUB DrawBackground
 'Video memory adress = &HB800 from 0000 to 3999
 DEF SEG = &HB800
 'FOR-NEXT loop, video memory is written from i% 160 to i% + 1 = 3999
 'Title bar takes up 0 - 159
 'NOTE: Even #s from 0 to 3999 are the chars while odds are the colors
 FOR i% = 160 TO 3998 STEP 2
  '176 = 
  POKE i%, 176
  '28 = Light Red on Dark Blue
  POKE i% + 1, 28
 NEXT i%
END SUB 'DrawBackground

SUB DrawNames (Start%, x1%, y1%, x2%)
 COLOR 9, 1
 IF Start% + NumTitles% > LastRecord% THEN temp% = LastRecord%
 IF Start% + NumTitles% <= LastRecord% THEN temp% = Start% + NumTitles% - 1
 FOR i% = Start% TO temp%
  LOCATE y1% + (i% - Start%), x1% - 1
  PRINT " "; RTRIM$(DFGameData(i%).GameName$); STRING$(x2% - x1% - LEN(RTRIM$(DFGameData(i%).GameName$)) + 1, " ")
 NEXT i%
 IF Start% + NumTitles% > LastRecord% THEN
  FOR i% = LastRecord% + 1 TO Start% + NumTitles% - 1
   temp% = i%
   DO UNTIL temp% <= NumTitles% - 1
    temp% = temp% - NumTitles%
   LOOP
   LOCATE y1% + temp%, x1% - 1
   PRINT STRING$(x2% - x1% + 2, " ")
  NEXT i%
 END IF
END SUB 'DrawNames (Start%, x1%, y1%, x2%)

SUB DrawOpStuff
 'Draws Options items.
 COLOR 7, 0
 LOCATE 6, 25
 PRINT DarkDir$
 LOCATE 9, 25
 PRINT LFDDir$
 LOCATE 12, 25
 PRINT LevelsDir$
 LOCATE 15, 28
 PRINT ListName$
 IF NumTitles% > 9 THEN
  LOCATE 15, 46
  PRINT USING "##"; NumTitles%
 ELSE
  LOCATE 15, 46
  PRINT "0";
  PRINT USING "#"; NumTitles%
 END IF
 COLOR 0, 1
 LOCATE 17, 34
 PRINT "͸";
 LOCATE 18, 34
 PRINT "           ";
 COLOR 10, 1
 LOCATE 18, 36
 PRINT CHR$(17); "       "; CHR$(16)
 COLOR 15, 1
 LOCATE 18, 38
 PRINT "Close"
 COLOR 0, 1
 LOCATE 19, 34
 PRINT ";";
END SUB 'DrawOpStuff

SUB DrawOptions (x1%, y1%)
 'Draw the unslected options
 COLOR 7, 1
 LOCATE y1% + 1, x1% + 1
 PRINT "͸ ͸ ";
 COLOR 0, 1
 PRINT "͸";
 COLOR 7, 1
 LOCATE y1% + 2, x1% + 1
 PRINT "                         ";
 COLOR 0, 1
 PRINT "          ";
 COLOR 10, 1
 LOCATE y1% + 2, x1% + 3
 PRINT CHR$(17); "      "; CHR$(16);
 LOCATE y1% + 2, x1% + 16
 PRINT CHR$(17); "         "; CHR$(16);
 LOCATE y1% + 2, x1% + 32
 PRINT CHR$(17); "      "; CHR$(16);
 COLOR 15, 1
 LOCATE y1% + 2, x1% + 5
 PRINT "Play";
 LOCATE y1% + 2, x1% + 18
 PRINT "Options";
 LOCATE y1% + 2, x1% + 34
 PRINT "Quit";
 COLOR 7, 1
 LOCATE y1% + 3, x1% + 1
 PRINT "; ; ";
 COLOR 0, 1
 PRINT ";";

END SUB

SUB DrawTitleBar (num%)
 'Locate the upper-left corner of the screen
 LOCATE 1, 1
 'Color White on Dark Blue
 COLOR 15, 1
 'Print 80 Dark Blue spaces
 PRINT STRING$(80, " ")
 'Go back to the upper-left corner
 LOCATE 1, 1
 'Center the title and version number on the new top bar.
 SELECT CASE num%
  CASE 0
   'Normal
   Center "Dark Frontend " + verNum$
  CASE 1
   'Tests
   Center "Dark Frontend " + verNum$ + " - Pre-Run Tests"
  CASE 2
   'Loading
   Center "Dark Frontend " + verNum$ + " - Loading Files"
  CASE 3
   'Goodbye
   Center "Thank you for using Dark Frontend " + verNum$ + "!"
  CASE 4
   'Run DARK.EXE
   Center "Dark Frontend " + verNum$ + " - Running Selected Game"
 END SELECT
END SUB

FUNCTION INIRead$ (FileNum%, Section$, Key$)
 SEEK #(FileNum%), 1
 DO
  LINE INPUT #(FileNum%), temp$
  IF EOF(FileNum%) THEN ERROR 77
 LOOP UNTIL LTRIM$(RTRIM$(UCASE$(temp$))) = "[" + UCASE$(Section$) + "]"
 DO
  LINE INPUT #(FileNum%), temp$
  IF INSTR(temp$, "=") <> 0 THEN IF LTRIM$(UCASE$(RTRIM$(LEFT$(temp$, INSTR(temp$, "=") - 1)))) = UCASE$(Key$) THEN EXIT DO
  IF EOF(FileNum%) OR LEFT$(LTRIM$(temp$), 1) = "[" THEN ERROR 78
 LOOP
 INIRead$ = RIGHT$(LTRIM$(RTRIM$(temp$)), LEN(temp$) - INSTR(temp$, "="))
END FUNCTION

FUNCTION LesserLEN% (i$, j$)
 ' Returns the lesser LEN i$ or j$
 IF LEN(i$) <= LEN(j$) THEN LesserLEN% = LEN(i$)
 IF LEN(i$) >= LEN(j$) THEN LesserLEN% = LEN(j$)
END FUNCTION

FUNCTION LimitInput$ (num%)
 LOCATE CSRLIN, POS(0), 1
 'Get user's input and feed it to a string of maximum length num%.
 i% = 0
 DO
  DO
   Key$ = INKEY$
  LOOP UNTIL Key$ <> ""
  SELECT CASE ASC(Key$)
   CASE 32 TO 126
    IF LEN(temp$) < num% THEN
     temp$ = temp$ + Key$
     PRINT Key$;
     IF LEN(temp$) = num% THEN LOCATE CSRLIN, POS(0), 0
    END IF
   CASE 8
    IF LEN(temp$) > 0 THEN
     temp$ = LEFT$(temp$, LEN(temp$) - 1)
     LOCATE CSRLIN, POS(0) - 1
     PRINT " ";
     LOCATE CSRLIN, POS(0) - 1, 1
    END IF
   CASE 13
    EXIT DO
  END SELECT
 LOOP
 LimitInput$ = temp$
 LOCATE CSRLIN, POS(0), 0
END FUNCTION 'LimitInput$ (num%)

FUNCTION MainWindow%
 WindWidth% = 0
 FOR i% = 0 TO LastRecord%
  IF LEN(RTRIM$(DFGameData(i%).GameName$)) > WindWidth% THEN WindWidth% = LEN(RTRIM$(DFGameData(i%).GameName$))
 NEXT i%
 IF WindWidth% < 39 THEN WindWidth% = 39
 x1% = INT((80 - (WindWidth% + 4)) / 2) + 1
 y1% = INT((25 - (6 + NumTitles%)) / 2) + 1
 x2% = 80 - INT((80 - (WindWidth% + 4)) / 2) - 1
 y2% = 25 - INT((25 - (6 + NumTitles%)) / 2) - 1
 SELECT CASE NumTitles%
  CASE 1, 3, 5, 7, 9, 11, 13, 15
   y2% = y2% + 1
 END SELECT
 MakeWindow x1%, y1%, x2%, y2%, 15, 1
 COLOR 15, 1
 LOCATE y1% + 4, x1%
 PRINT ""; STRING$(x2% - x1% - 1, ""); ""
 j% = 0
 DrawOptions x1%, y1%
 DrawNames 0, x1% + 2, y1% + 5, x2% - 1
 Game% = 0
 DO
  SELECT CASE j%
   CASE 0
    COLOR 14, 1
    LOCATE y1% + 1, x1% + 1
    PRINT "͸ ";
    COLOR 14, 1
    LOCATE y1% + 2, x1% + 1
    PRINT " ";
    COLOR 10, 1
    PRINT CHR$(17);
    COLOR 15, 1
    PRINT " PLAY ";
    COLOR 10, 1
    PRINT CHR$(16);
    COLOR 14, 1
    PRINT "  ";
    COLOR 14, 1
    LOCATE y1% + 3, x1% + 1
    PRINT "; ";
   CASE 1
    COLOR 14, 1
    LOCATE y1% + 1, x1% + 14
    PRINT "͸ ";
    COLOR 14, 1
    LOCATE y1% + 2, x1% + 14
    PRINT " ";
    COLOR 10, 1
    PRINT CHR$(17);
    COLOR 15, 1
    PRINT " OPTIONS ";
    COLOR 10, 1
    PRINT CHR$(16);
    COLOR 14, 1
    PRINT "  ";
    COLOR 14, 1
    LOCATE y1% + 3, x1% + 14
    PRINT "; ";
   CASE 2
    COLOR 14, 1
    LOCATE y1% + 1, x1% + 30
    PRINT "͸";
    COLOR 14, 1
    LOCATE y1% + 2, x1% + 30
    PRINT " ";
    COLOR 10, 1
    PRINT CHR$(17);
    COLOR 15, 1
    PRINT " QUIT ";
    COLOR 10, 1
    PRINT CHR$(16);
    COLOR 14, 1
    PRINT " ";
    COLOR 14, 1
    LOCATE y1% + 3, x1% + 30
    PRINT ";";
  END SELECT
  temp% = Game%
  DO UNTIL temp% <= NumTitles% - 1
   temp% = temp% - NumTitles%
  LOOP
  COLOR 14, 5
  LOCATE y1% + 5 + temp%, x1% + 1
  PRINT " ";
  PRINT RTRIM$(DFGameData(Game%).GameName$);
  PRINT STRING$(x2% - x1% - LEN(RTRIM$(DFGameData(Game%).GameName$)) - 2, " ")
  Key$ = INKEY$
  SELECT CASE Key$
   CASE CHR$(0) + "K"
    j% = j% - 1
    DrawOptions x1%, y1%
    IF j% = -1 THEN j% = 2
   CASE CHR$(0) + "M"
    j% = j% + 1
    DrawOptions x1%, y1%
    IF j% = 3 THEN j% = 0
   CASE CHR$(0) + "H"
    Game% = Game% - 1
    IF Game% < 0 THEN Game% = 0
    temp% = Game%
    DO UNTIL temp% <= NumTitles% - 1
     temp% = temp% - NumTitles%
    LOOP
    DrawNames Game% - temp%, x1% + 2, y1% + 5, x2% - 1
   CASE CHR$(0) + "P"
    Game% = Game% + 1
    IF Game% > LastRecord% THEN Game% = LastRecord%
    temp% = Game%
    DO UNTIL temp% <= NumTitles% - 1
     temp% = temp% - NumTitles%
    LOOP
    DrawNames Game% - temp%, x1% + 2, y1% + 5, x2% - 1
   CASE CHR$(27)
    COLOR 7, 0
    CLS
    DrawTitleBar 3
    COLOR 7, 0
    END
   CASE CHR$(13), CHR$(32)
    SELECT CASE j%
     CASE 2
      COLOR 7, 0
      CLS
      DrawTitleBar 3
      COLOR 7, 0
      END
     CASE 1
      ClearWindow x1%, y1%, x2%, y2%
      MainWindow% = -1
      EXIT FUNCTION
     CASE 0
      ClearWindow x1%, y1%, x2%, y2%
      MainWindow% = Game%
      EXIT FUNCTION
    END SELECT
  END SELECT
 LOOP
END FUNCTION 'MainWindow%

SUB MakeWindow (x1%, y1%, x2%, y2%, c1%, c2%)
 'Draw the window and shadow
 COLOR c1%, c2%
 LOCATE y1%, x1%
 PRINT "";
 PRINT STRING$(x2% - x1% - 1, "")
 FOR i% = 1 TO y2% - y1%
  COLOR c1%, c2%
  LOCATE i% + y1%, x1%
  PRINT "";
  PRINT STRING$(x2% - x1% - 1, " ");
  PRINT "";
  COLOR 4, 0
  PRINT "";
 NEXT i%
 COLOR c1%, c2%
 LOCATE y2%, x1%
 PRINT "";
 PRINT STRING$(x2% - x1% - 1, "")
 LOCATE y1%, x2%
 PRINT "";
 LOCATE y2%, x2%
 PRINT "";
 COLOR 4, 0
 PRINT "";
 LOCATE y2% + 1, x1% + 2
 PRINT STRING$(x2% - x1% + 1, "")
 COLOR c1%, c2%
END SUB 'MakeWindow (x1%, y1%, x2%, y2%, c1%, c2%)

SUB Options
 MakeWindow 23, 4, 56, 20, 15, 1
 COLOR 14, 1
 LOCATE 5, 24
 PRINT "< ";
 COLOR 12, 1
 PRINT "DARK FORCES DIRECTORY";
 COLOR 14, 1
 PRINT " >Ŀ";
 LOCATE 6, 24
 PRINT "                              ";
 LOCATE 7, 24
 PRINT "";
 COLOR 7, 0
 LOCATE 6, 25
 PRINT "                              ";
 COLOR 14, 1
 LOCATE 8, 24
 PRINT "< ";
 COLOR 12, 1
 PRINT "DARK FORCES LFD DIRECTORY";
 COLOR 14, 1
 PRINT " >Ŀ";
 LOCATE 9, 24
 PRINT "                              ";
 LOCATE 10, 24
 PRINT "";
  COLOR 7, 0
 LOCATE 9, 25
 PRINT "                              ";
 COLOR 14, 1
 LOCATE 11, 24
 PRINT "< ";
 COLOR 12, 1
 PRINT "ADD-ON LEVELS DIRECTORY";
 COLOR 14, 1
 PRINT " >Ŀ";
 LOCATE 12, 24
 PRINT "                              ";
 LOCATE 13, 24
 PRINT "";
 COLOR 7, 0
 LOCATE 12, 25
 PRINT "                              ";
 COLOR 14, 1
 LOCATE 14, 27
 PRINT "< ";
 COLOR 12, 1
 PRINT "LISTFILE";
 COLOR 14, 1
 PRINT " >< ";
 COLOR 12, 1
 PRINT "#GAMES";
 COLOR 14, 1
 PRINT " >";
 LOCATE 15, 27
 PRINT "                      ";
 LOCATE 16, 27
 PRINT "";
 COLOR 7, 0
 LOCATE 15, 28
 PRINT "            ";
 DrawOpStuff
 k% = 0
 i% = 0
 DO
  SELECT CASE i%
   CASE 0
    k% = 0
    COLOR 15, 0
    LOCATE 6, 25
    PRINT DarkDir$
   CASE 1
    k% = 0
    COLOR 15, 0
    LOCATE 9, 25
    PRINT LFDDir$
   CASE 2
    k% = 0
    COLOR 15, 0
    LOCATE 12, 25
    PRINT LevelsDir$
   CASE 3
    k% = 0
    COLOR 15, 0
    LOCATE 15, 28
    PRINT ListName$
   CASE 4
    k% = 0
    COLOR 15, 0
    IF NumTitles% > 9 THEN
     LOCATE 15, 46
     PRINT USING "##"; NumTitles%
    ELSE
     LOCATE 15, 46
     PRINT "0";
     PRINT USING "#"; NumTitles%
    END IF
   CASE 5
    IF k% <> 5 THEN
     k% = 5
     COLOR 14, 1
     LOCATE 17, 34
     PRINT "͸";
     LOCATE 18, 34
     PRINT "           ";
     COLOR 10, 1
     LOCATE 18, 36
     PRINT CHR$(17); "       "; CHR$(16)
     COLOR 15, 1
     LOCATE 18, 38
     PRINT "CLOSE"
     COLOR 14, 1
     LOCATE 19, 34
     PRINT ";";
    END IF
  END SELECT
  Key$ = INKEY$
  IF Key$ = CHR$(0) + "H" THEN
   i% = i% - 1
   IF i% = 3 THEN i% = 2
   IF i% = 4 THEN i% = 3
   IF i% = -1 THEN i% = 5
   DrawOpStuff
  END IF
  IF Key$ = CHR$(0) + "P" THEN
   i% = i% + 1
   IF i% = 4 THEN i% = 5
   IF i% = 6 THEN i% = 0
   DrawOpStuff
  END IF
  IF Key$ = CHR$(0) + "M" OR Key$ = CHR$(0) + "K" THEN
   j% = i%
   IF i% = 3 THEN j% = 4
   IF i% = 4 THEN j% = 3
   i% = j%
   DrawOpStuff
  END IF
  IF Key$ = CHR$(27) THEN
   ClearWindow 23, 4, 56, 20
   WriteFile
   EXIT SUB
  END IF
  IF Key$ = CHR$(13) OR Key$ = " " THEN
   SELECT CASE i%
    CASE 5
     ClearWindow 23, 4, 56, 20
     WriteFile
     EXIT SUB
    CASE 4
     COLOR 15, 0
     LOCATE 15, 46
     PRINT "  ";
     LOCATE 15, 46, 1
     DO
      DO
       Key$ = INKEY$
      LOOP UNTIL Key$ <> ""
     LOOP UNTIL ASC(Key$) >= 48 AND ASC(Key$) <= 49
     PRINT Key$;
     IF Key$ = "0" THEN
      DO
       DO
	Key2$ = INKEY$
       LOOP UNTIL Key2$ <> ""
      LOOP UNTIL ASC(Key2$) >= 49 AND ASC(Key2$) <= 57
     ELSE
      DO
       DO
	Key2$ = INKEY$
       LOOP UNTIL Key2$ <> ""
      LOOP UNTIL ASC(Key2$) >= 48 AND ASC(Key2$) <= 53
     END IF
     PRINT Key2$;
     LOCATE 1, 1, 0
     NumTitles% = (VAL(Key$) * 10) + VAL(Key2$)
    CASE 3
     COLOR 15, 0
     LOCATE 15, 28
     PRINT "            ";
     LOCATE 15, 28
     ListName$ = LimitInput$(12)
    CASE 2
     COLOR 15, 0
     LOCATE 12, 25
     PRINT "                              ";
     LOCATE 12, 25
     LevelsDir$ = LimitInput$(30)
    CASE 1
     COLOR 15, 0
     LOCATE 9, 25
     PRINT "                              ";
     LOCATE 9, 25
     LFDDir$ = LimitInput$(30)
    CASE 0
     COLOR 15, 0
     LOCATE 6, 25
     PRINT "                              ";
     LOCATE 6, 25
     DarkDir$ = LimitInput$(30)
   END SELECT
  END IF
 LOOP
END SUB 'Options

SUB PlayGame (Number%)
 'Run Dark Forces! Yes!
 COLOR 7, 0
 CLS
 DrawTitleBar 4
 IF DFGameData(Number%).GOBName$ = "۲Dark" THEN
  CHDIR DarkDir$
  SHELL "dark.exe -shots"
  CHDIR LevelsDir$
  'Draw the title and the version number in a blue bar
  DrawTitleBar 0
  'Draw the wallpaper
  DrawBackground
  EXIT SUB
 END IF
 CHDIR LevelsDir$ + "\" + RTRIM$(DFGameData(Number%).GOBName$)
 statement$ = "copy " + RTRIM$(DFGameData(Number%).GOBName$) + ".GOB " + DarkDir$
 SHELL statement$
 IF RTRIM$(DFGameData(Number%).LFDName$) <> "" THEN
  NAME LFDDir$ + "\DFBRIEF.LFD" AS LFDDir$ + "\DFBRIEF.DFE"
  statement$ = "copy " + RTRIM$(DFGameData(Number%).LFDName$) + ".LFD " + LFDDir$
  SHELL statement$
  NAME LFDDir$ + "\" + RTRIM$(DFGameData(Number%).LFDName$) + ".LFD" AS LFDDir$ + "\DFBRIEF.LFD"
 END IF
 IF RTRIM$(DFGameData(Number%).CRAWLName$) <> "" THEN
  NAME LFDDir$ + "\FTEXTCRA.LFD" AS LFDDir$ + "\FTEXTCRA.DFE"
  statement$ = "copy " + RTRIM$(DFGameData(Number%).CRAWLName$) + ".LFD " + LFDDir$
  SHELL statement$
  NAME LFDDir$ + "\" + RTRIM$(DFGameData(Number%).CRAWLName$) + ".LFD" AS LFDDir$ + "\FTEXTCRA.LFD"
 END IF
 IF RTRIM$(DFGameData(Number%).Others0$) <> "" THEN
  statement$ = "copy " + RTRIM$(DFGameData(Number%).Others0$) + " " + DarkDir$
  SHELL statement$
 END IF
 IF RTRIM$(DFGameData(Number%).Others1$) <> "" THEN
  statement$ = "copy " + RTRIM$(DFGameData(Number%).Others1$) + " " + DarkDir$
  SHELL statement$
 END IF
 IF RTRIM$(DFGameData(Number%).Others2$) <> "" THEN
  statement$ = "copy " + RTRIM$(DFGameData(Number%).Others2$) + " " + DarkDir$
  SHELL statement$
 END IF
 IF RTRIM$(DFGameData(Number%).Others3$) <> "" THEN
  statement$ = "copy " + RTRIM$(DFGameData(Number%).Others3$) + " " + DarkDir$
  SHELL statement$
 END IF
 IF RTRIM$(DFGameData(Number%).Others4$) <> "" THEN
  statement$ = "copy " + RTRIM$(DFGameData(Number%).Others4$) + " " + DarkDir$
  SHELL statement$
 END IF
 IF RTRIM$(DFGameData(Number%).Others5$) <> "" THEN
  statement$ = "copy " + RTRIM$(DFGameData(Number%).Others5$) + " " + DarkDir$
  SHELL statement$
 END IF
 IF RTRIM$(DFGameData(Number%).Others6$) <> "" THEN
  statement$ = "copy " + RTRIM$(DFGameData(Number%).Others6$) + " " + DarkDir$
  SHELL statement$
 END IF
 IF RTRIM$(DFGameData(Number%).Others7$) <> "" THEN
  statement$ = "copy " + RTRIM$(DFGameData(Number%).Others7$) + " " + DarkDir$
  SHELL statement$
 END IF
 IF RTRIM$(DFGameData(Number%).Others8$) <> "" THEN
  statement$ = "copy " + RTRIM$(DFGameData(Number%).Others8$) + " " + DarkDir$
  SHELL statement$
 END IF
 IF RTRIM$(DFGameData(Number%).Others9$) <> "" THEN
  statement$ = "copy " + RTRIM$(DFGameData(Number%).Others9$) + " " + DarkDir$
  SHELL statement$
 END IF
 CHDIR DarkDir$
 statement$ = "dark -u" + RTRIM$(DFGameData(Number%).GOBName$) + ".gob -shots"
 SHELL statement$
 KILL RTRIM$(DFGameData(Number%).GOBName$) + ".gob"
 IF RTRIM$(DFGameData(Number%).Others0$) <> "" THEN KILL RTRIM$(DFGameData(Number%).Others0$)
 IF RTRIM$(DFGameData(Number%).Others1$) <> "" THEN KILL RTRIM$(DFGameData(Number%).Others1$)
 IF RTRIM$(DFGameData(Number%).Others2$) <> "" THEN KILL RTRIM$(DFGameData(Number%).Others2$)
 IF RTRIM$(DFGameData(Number%).Others3$) <> "" THEN KILL RTRIM$(DFGameData(Number%).Others3$)
 IF RTRIM$(DFGameData(Number%).Others4$) <> "" THEN KILL RTRIM$(DFGameData(Number%).Others4$)
 IF RTRIM$(DFGameData(Number%).Others5$) <> "" THEN KILL RTRIM$(DFGameData(Number%).Others5$)
 IF RTRIM$(DFGameData(Number%).Others6$) <> "" THEN KILL RTRIM$(DFGameData(Number%).Others6$)
 IF RTRIM$(DFGameData(Number%).Others7$) <> "" THEN KILL RTRIM$(DFGameData(Number%).Others7$)
 IF RTRIM$(DFGameData(Number%).Others8$) <> "" THEN KILL RTRIM$(DFGameData(Number%).Others8$)
 IF RTRIM$(DFGameData(Number%).Others9$) <> "" THEN KILL RTRIM$(DFGameData(Number%).Others9$)
 CHDIR LFDDir$
 IF RTRIM$(DFGameData(Number%).LFDName$) <> "" THEN
  KILL "DFBRIEF.LFD"
  NAME "DFBRIEF.DFE" AS "DFBRIEF.LFD"
 END IF
 IF RTRIM$(DFGameData(Number%).CRAWLName$) <> "" THEN
  KILL "FTEXTCRA.LFD"
  NAME "FTEXTCRA.DFE" AS "FTEXTCRA.LFD"
 END IF
 CHDIR LevelsDir$
 'Draw the title and the version number in a blue bar
 DrawTitleBar 0
 'Draw the wallpaper
 DrawBackground
END SUB 'PlayGame (Number%)

SUB SortGames
 ' Bubbles DARK FORCES to the top.
 dummy% = -1
 FOR i% = 0 TO LastRecord%
  IF DFGameData(i%).GOBName$ = "۲Dark" THEN
   SWAP DFGameData(i%), DFGameData(0)
   EXIT FOR
  END IF
 NEXT i%
 'Sorts games alphabetically.  In each loop, drops `heaviest' game to bottom.
 FOR i% = LastRecord% TO 1 STEP -1
  FOR j% = 1 TO i% - 1
   IF DFGameData(j%).GameName$ <> DFGameData(j% + 1).GameName$ THEN
    FOR k% = 1 TO LesserLEN(RTRIM$(DFGameData(j%).GameName$), RTRIM$(DFGameData(j% + 1).GameName$))
     IF ASC(MID$(LCASE$(RTRIM$(DFGameData(j%).GameName$)), k%, 1)) > ASC(MID$(LCASE$(RTRIM$(DFGameData(j% + 1).GameName$)), k%, 1)) THEN
      SWAP DFGameData(j%), DFGameData(j% + 1)
      EXIT FOR
     END IF
     IF ASC(MID$(LCASE$(RTRIM$(DFGameData(j%).GameName$)), k%, 1)) < ASC(MID$(LCASE$(RTRIM$(DFGameData(j% + 1).GameName$)), k%, 1)) THEN EXIT FOR
     IF k% = LesserLEN(DFGameData(j%).GameName$, DFGameData(j% + 1).GameName$) THEN
      SWAP DFGameData(j%), DFGameData(j% + 1)
     END IF
    NEXT k%
  END IF
  NEXT j%
 NEXT i%
END SUB

SUB Tests
DIM temp2$(9)
 'Video memory adress = &HB800 from 0000 to 3999
 DEF SEG = &HB800
 'Reset TestFailed%
 TestFailed% = FALSE
 'Draw the title and the version number in a blue bar
 DrawTitleBar 1
 'Fix scroll
 VIEW PRINT 2 TO 25
 'Color Light Gray on Black
 COLOR 7, 0
 '&HB800:0160 should be = 32 or 0 or 255
 IF PEEK(160) <> 32 AND PEEK(160) <> 0 AND PEEK(160) <> 255 THEN TestFailed% = TRUE
 'Check to see if &HB800:0160 changed
 PRINT "Testing for color mode..."
 IF PEEK(160) <> 84 THEN TestFailed% = TRUE
 'Error message.  Monochrome monitor probrably the culprit
 IF TestFailed% THEN
  BEEP
  PRINT "Your video memory is not in memory address $B800.  This is possibly"
  PRINT "due to you having a monochrome monitor, or using a DOS emulator which"
  PRINT "does not identify writing to video memory.  If this program were to"
  PRINT "continue, it could overwrite something valuable in your memory.  Aborting..."
  PRINT
  END
 END IF
 'Successful
 PRINT "Video memory at [$B800:0000-3999]"
 'Reset Text Viewport so DrawTitleBar works
 VIEW PRINT
 CLS
 'Draw the title and the version number in a blue bar
 DrawTitleBar 2
 'Fix scroll and color
 VIEW PRINT 2 TO 25
 COLOR 7, 0
 'Open files
 PRINT "Opening DFRNTEND.INI..."
 ErrSpec% = 32767
 ON ERROR GOTO nofile
  OPEN "DFRNTEND.INI" FOR INPUT AS #1
 ON ERROR GOTO 0
 PRINT "DFRNTEND.INI opened without error."
 IF EOF(1) THEN
  PRINT "File is empty.  Using default settings..."
 ELSE
  ON ERROR GOTO nofile
   ListName$ = INIRead$(1, "Main", "ListFile")
   DarkDir$ = INIRead$(1, "Main", "DarkDir")
   LFDDir$ = INIRead$(1, "Main", "LFDDir")
   LevelsDir$ = INIRead$(1, "Main", "LevelsDir")
   NumTitles% = VAL(INIRead$(1, "Main", "NumTitlesOnScreen"))
  ON ERROR GOTO 0
 END IF
 CLOSE #1
 'Open list of games
 PRINT "Opening List in "; ListName$; "..."
 ErrSpec% = 30000
 ON ERROR GOTO nofile
  OPEN ListName$ FOR INPUT AS #2
 ON ERROR GOTO 0
 IF EOF(2) THEN
  PRINT "File is empty.  List will be empty except for Dark Forces."
 ELSE
  LastRecord% = -1
  DFGameData(0).GameName$ = ""
   DO
    ON ERROR GOTO nofile
     LastRecord% = LastRecord% + 1
     INPUT #2, DFGameData(LastRecord%).GOBName$
     IF DFGameData(LastRecord%).GOBName$ = "۲Dark" THEN DFGameData(LastRecord%).GameName$ = "Dark Forces"
    ON ERROR GOTO 0
   LOOP UNTIL EOF(2)
 END IF
 CLOSE #2
 'Get rest of data.  LastRecord% is last entry.
 PRINT "Opening and reading lists..."
 ON ERROR GOTO nofile
 dummy% = FALSE
 FOR j% = 0 TO LastRecord%
  ErrSpec% = j%
  IF DFGameData(j%).GOBName$ <> "۲Dark" THEN
   OPEN LevelsDir$ + "\" + DFGameData(j%).GOBName$ + "\" + DFGameData(j%).GOBName$ + ".INI" FOR INPUT AS #3
   DFGameData(j%).GameName$ = INIRead(3, RTRIM$(DFGameData(j%).GOBName$), "GameName")
   DFGameData(j%).LFDName$ = INIRead(3, RTRIM$(DFGameData(j%).GOBName$), "LFDName")
   DFGameData(j%).CRAWLName$ = INIRead(3, RTRIM$(DFGameData(j%).GOBName$), "CRAWLName")
   DFGameData(j%).OtherNum% = VAL(INIRead(3, RTRIM$(DFGameData(j%).GOBName$), "Others"))
   FOR k% = 0 TO 9
    temp2$(k%) = ""
   NEXT k%
   FOR k% = 0 TO DFGameData(j%).OtherNum% - 1
    temp2$(k%) = INIRead$(3, RTRIM$(DFGameData(j%).GOBName$), "Other" + LTRIM$(RTRIM$(STR$(k%))))
   NEXT k%
   DFGameData(j%).Others0$ = temp2$(0)
   DFGameData(j%).Others1$ = temp2$(1)
   DFGameData(j%).Others2$ = temp2$(2)
   DFGameData(j%).Others3$ = temp2$(3)
   DFGameData(j%).Others4$ = temp2$(4)
   DFGameData(j%).Others5$ = temp2$(5)
   DFGameData(j%).Others6$ = temp2$(6)
   DFGameData(j%).Others7$ = temp2$(7)
   DFGameData(j%).Others8$ = temp2$(8)
   DFGameData(j%).Others9$ = temp2$(9)
   CLOSE #3
  ELSE
   dummy% = TRUE
  END IF
 NEXT j%
 IF NOT dummy% THEN
  DFGameData(LastRecord% + 1).GOBName$ = "۲Dark"
  LastRecord% = LastRecord% + 1
 END IF
 ON ERROR GOTO 0
 'Successful
 PRINT "...Successful!"
 'Reset test viewport
 VIEW PRINT
END SUB 'Tests

SUB WriteFile
 OPEN "DFRNTEND.INI" FOR OUTPUT AS #1
 PRINT #1, "[Main]"
 PRINT #1, "ListFile="; ListName$
 PRINT #1, "DarkDir="; DarkDir$
 PRINT #1, "LFDDir="; LFDDir$
 PRINT #1, "LevelsDir="; LevelsDir$
 PRINT #1, "NumTitlesOnScreen="; STR$(NumTitles%);
 CLOSE #1
END SUB 'WriteFile

